#pragma once

//! @file Mix/AtomicValue.h
//! @brief Ag~bNϐNXCN[ht@C

namespace Mix{

	//! @class AtomicValue
	//! @brief Ag~bNϐNX
	class _MIX_DLL_API AtomicValue
	{
	private:
		volatile Long32 m_Value;

	public:
		//! @brief RXgN^
		AtomicValue( void )
		{
			Set( 0 );
		}
		//! @brief RXgN^
		//! @param[in] v l
		AtomicValue( const Long32 v )
		{
			Set( v );
		}

	public:
		//! @brief lݒ肵܂
		//! @param[in] v ݒ肷l
		//! @return ݒO̒l
		Long32 Set( Long32 v )
		{
			return ::InterlockedExchange( &m_Value, v );
		}
		//! @brief l擾܂
		//! @return l
		Long32 Get( void ) const
		{
			return ::InterlockedExchangeAdd( const_cast<volatile Long32*>( &m_Value ), 0 );
		}
		//! @brief w肵lZ܂
		//! @param[in] v Zl
		//! @return ZO̒l
		Long32 Add( Long32 v )
		{
			return ::InterlockedExchangeAdd( &m_Value, v );
		}
		//! @brief l₵܂
		//! @return ₵l
		Long32 Increment( void )
		{
			return ::InterlockedIncrement( &m_Value );
		}
		//! @brief l炵܂
		//! @return 炵l
		Long32 Decrement( void )
		{
			return ::InterlockedDecrement( &m_Value );
		}
		//! @brief  cv  gƔrAꍇ́AgɈ v ݒ肵܂
		//! @param[in] v ݒ肷l
		//! @param[in] cv rl
		//! @return ݒO̒l
		Long32 CompareAndSet( Long32 v, Long32 cv )
		{
			return ::InterlockedCompareExchange( &m_Value, v, cv );
		}

		//! @brief lݒ肵܂
		//! @param[in] v ݒ肷l
		void operator = ( Long32 v )
		{
			Set( v );
		}
	};
}
