#pragma once

//! @file Mix/Common.h
//! @brief ʃCN[ht@C


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CN[h
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <windows.h>

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// [jO
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#pragma warning ( disable: 4100 )	//֐̈xQƂĂȂƂɂłx𖳎( C^[tF[X̔hȂ )
#pragma warning ( disable: 4201 )	//\̂̌x𖳎
#pragma warning ( disable: 4786 )	//255蒷V{̌x𖳎

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// DLL̐ݒ
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifdef _MIX_DLL
	#ifdef _MIX_DLL_EXPORTS
		//! @def _MIX_DLL_API
		//! @brief DLLGNX|[g`
		#define _MIX_DLL_API __declspec( dllexport )
	#else // _MIX_DLL_EXPORTS
		//! @def _MIX_DLL_API
		//! @brief DLLC|[g`
		#define _MIX_DLL_API __declspec( dllimport )
	#endif // _MIX_DLL_EXPORTS
#else //_MIX_DLL
	//! @def _MIX_DLL_API
	//! @brief DLL`
	#define _MIX_DLL_API
#endif //_MIX_DLL


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ϐ`
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//! @typedef Int8
//! @brief t8rbg
typedef char Int8;
//! @typedef UInt8
//! @brief 8rbg
typedef unsigned char UInt8;
//! @typedef Int16
//! @brief t16rbg
typedef short Int16;
//! @typedef UInt16
//! @brief 16rbg
typedef unsigned short UInt16;
//! @typedef Int32
//! @brief t32rbg
typedef int Int32;
//! @typedef UInt32
//! @brief 32rbg
typedef unsigned int UInt32;
//! @typedef Int64
//! @brief t64rbg
typedef long long Int64;
//! @typedef UInt64
//! @brief 64rbg
typedef unsigned long long UInt64;
//! @typedef Long32
//! @brief t32rbg
typedef long Long32;
//! @typedef ULong32
//! @brief 32rbg
typedef unsigned long ULong32;
//! @typedef Float32
//! @brief 32rbg_
typedef float Float32;
//! @typedef Float64
//! @brief 64rbg_
typedef double Float64;

//! @var typedef BOOL Boolean
//! @brief 32rbgu[A
typedef BOOL Boolean;
//! @def True
//! @brief Boolean^̐^l
#define True TRUE
//! @def False
//! @brief Boolean^̋Ul
#define False FALSE


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CN[h
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "Mix/Memory.h"
#include "Mix/String.h"
#include "Mix/Point.h"
#include "Mix/Rectangle.h"
#include "Mix/RectangleF.h"
#include "Mix/Vector2.h"
#include "Mix/Vector3.h"
#include "Mix/Vector4.h"
#include "Mix/Quaternion.h"
#include "Mix/Matrix3x3.h"
#include "Mix/Matrix4x4.h"
#include "Mix/Geometry/AABB.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// OԂ̒`
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//! @namespace Mix
//! @brief [g
namespace Mix{

	class IEngine;
	class IWindow;

	//! @enum CPU_FEATURE_FLAG
	//! @brief CPUT|[gtO
	enum CPU_FEATURE_FLAG
	{
		CPU_FEATURE_MMX		= 0x00000001,	//!< MMX
		CPU_FEATURE_SSE		= 0x00000002,	//!< SSE
		CPU_FEATURE_SSE2	= 0x00000004,	//!< SSE2
		CPU_FEATURE_3DNOW	= 0x00000008,	//!< 3DNOW
	};

	//! @struct CPU_INFO
	//! @brief CPU\
	struct CPU_INFO
	{
		wchar_t venderName[13];	//!< x_[
		wchar_t modelName[30];	//!< f

		UInt32 family;		//!< t@~[
		UInt32 model;		//!< f
		UInt32 revision;	//!< rW
		UInt32 feature;		//!< T|[gtO( Mix::CPU_FEATURE_FLAG 񋓒萔 )
		UInt32 osFeature;	//!< OST|[gtO( Mix::CPU_FEATURE_FLAG 񋓒萔 )
	};

	//! @brief CX^X̃nh擾܂
	//! @return nhԂ܂
	_MIX_DLL_API HINSTANCE GetInstanceHandle( void );

	//! @brief CPU擾܂
	//! @return CPU\ Mix::CPU_INFO \̂Ԃ܂
	const Mix::CPU_INFO& GetCPUInfo( void );

	//! @brief GW̃|C^擾܂
	//! @return GW̃|C^\ Mix::IEngine C^[tF[X̃|C^Ԃ܂
	_MIX_DLL_API Mix::IEngine* GetEnginePtr( void );
	//! @brief GW擾܂
	//! @param[out] ppEngine GW\ Mix::IEngine C^[tF[X̃|C^̃AhX
	//! @note 擾GW͎QƃJE^ +1 ܂B
	_MIX_DLL_API Boolean GetEngine( Mix::IEngine** ppEngine );

	//! @brief EBhẼ|C^擾܂
	//! @return EBhE\ Mix::IWindow C^[tF[X̃|C^Ԃ܂
	_MIX_DLL_API Mix::IWindow* GetWindowPtr( void );
	//! @brief EBhE擾܂
	//! @param[out] ppWindow EBhE\ Mix::IWindow C^[tF[X̃|C^̃AhX
	//! @return ꍇ True Ԃ܂
	//! @note 擾EBhE͎QƃJE^ +1 ܂B
	_MIX_DLL_API Boolean GetWindow( Mix::IWindow** ppWindow );

	//! @brief ̕擾܂
	//! @param[in] value 𔻒肷l
	//! @return ̕Ԃ܂
	_MIX_DLL_API Int32 Sign( Int32 value );
	//! @brief _̕擾܂
	//! @param[in] value 𔻒肷l
	//! @return _̕Ԃ܂
	_MIX_DLL_API Float32 SignF( Float32 value );

	//! @brief _̕擾܂
	//! @param[in] value ߂l
	//! @return _̕Ԃ܂
	_MIX_DLL_API Float32 SqrtF( const Float32& value );

	//! @brief _̋t擾܂
	//! @param[in] value t߂l
	//! @return tԂ܂
	_MIX_DLL_API Float32 InvF( Float32 value );
	//! @brief _̋̕t擾܂
	//! @param[in] value ̋t߂l
	//! @return ̋tԂ܂
	_MIX_DLL_API Float32 InvSqrtF( Float32 value );

	//! @brief ܂
	_MIX_DLL_API void InitRand( void );
	//! @brief ܂
	//! @param[in] seed ̂ƂɂȂ鐔
	_MIX_DLL_API void InitRand( UInt32 seed );
	//! @brief ܂
	//! @param[in] seeds ̂ƂɂȂ鐔̔z
	//! @param[in] numSeed ̂ƂɂȂ鐔̔z̗vf̐
	_MIX_DLL_API void InitRand( UInt32* seeds, UInt32 numSeed );
	//! @brief ̗擾܂
	//! @return ̗Ԃ܂
	_MIX_DLL_API UInt32 Rand( void );
	//! @brief ̗擾܂
	//! @param[in] maxRnd 擾闐̍ől
	//! @return ̗Ԃ܂
	_MIX_DLL_API UInt32 Rand( UInt32 maxRnd );
	//! @brief ̗擾܂
	//! @param[in] r0 擾闐̊Jnl
	//! @param[in] r1 擾闐̏Il
	//! @return ̗Ԃ܂
	_MIX_DLL_API UInt32 Rand( UInt32 r0, UInt32 r1 );
	//! @brief _̗( 0.0f`1.0f )擾܂
	//! @return _̗Ԃ܂
	_MIX_DLL_API Float32 RandF( void );
	//! @brief _̗擾܂
	//! @param[in] maxRnd 擾闐̍ől
	//! @return _̗Ԃ܂
	_MIX_DLL_API Float32 RandF( Float32 maxRnd );
	//! @brief _̗擾܂
	//! @param[in] r0 擾闐̊Jnl
	//! @param[in] r1 擾闐̏Il
	//! @return _̗Ԃ܂
	_MIX_DLL_API Float32 RandF( Float32 r0, Float32 r1 );

	//! @brief _̐`Ԃ܂
	//! @param[in] a Ԍ
	//! @param[in] b Ԑ
	//! @param[in] t ԌW( 0.0f`1.0f )
	//! @return Ԃꂽ_Ԃ܂
	_MIX_DLL_API Float32 LerpF( Float32 a, Float32 b, Float32 t );

	//! @brief w肳ꂽxNgQ{̐ȃxNg߂܂
	//! @param[in] n ̓xNg\ Mix::Vector3 NX
	//! @param[out] p o̓xNgP\ Mix::Vector3 NX
	//! @param[out] q o̓xNgQ\ Mix::Vector3 NX
	_MIX_DLL_API void PlaneSpace( const Mix::Vector3& n, Mix::Vector3& p, Mix::Vector3& q );

	//! @brief w肳ꂽsQ{̃xNgŒZ̉]߂܂
	//! @param[in] v0 ڂ̃xNg\ Mix::Vector3 NX
	//! @param[in] v1 ڂ̃xNg\ Mix::Vector3 NX
	//! @return ]\ Mix::Quaternion NXԂ܂
	_MIX_DLL_API Mix::Quaternion ShortestArc( const Mix::Vector3& v0, const Mix::Vector3& v1 );

	//! @brief [hWXN[W֕ϊ܂
	//! @param[in] viewMat r[s\ Mix::Matrix4x4 NX
	//! @param[in] projMat ˉes\ Mix::Matrix4x4 NX
	//! @param[in] worldPos [hW\ Mix::Vector3 NX
	//! @param[in] screenSize XN[̃TCY\ Mix::Vector2 NX
	//! @return XN[W\ Mix::Vector3 NXԂ܂
	_MIX_DLL_API Mix::Vector3 Project( const Mix::Matrix4x4& viewMat, const Mix::Matrix4x4& projMat, const Mix::Vector3& worldPos, const Mix::Vector2& screenSize );
	//! @brief XN[W[hW֕ϊ܂
	//! @param[in] viewMat r[s\ Mix::Matrix4x4 NX
	//! @param[in] projMat ˉes\ Mix::Matrix4x4 NX
	//! @param[in] screenPos XN[W( z ͎ˉeԂ̒l 0.0f ` 1.0f )\ Mix::Vector3 NX
	//! @param[in] screenSize XN[̃TCY\ Mix::Vector2 NX
	//! @return [hW\ Mix::Vector3 NXԂ܂
	_MIX_DLL_API Mix::Vector3 Unproject( const Mix::Matrix4x4& viewMat, const Mix::Matrix4x4& projMat, const Mix::Vector3& screenPos, const Mix::Vector2& screenSize );

	//! @brief pX܂
	//! @param[in] pBaseDirPath Pڂ̃fBNgpX
	//! @param[in] pRelPath Qڂ̃fBNgAt@CpX
	//! @param[out] outPath ꂽpX
	//! @return ꍇ True Ԃ܂
	_MIX_DLL_API Boolean CombinePath( const wchar_t* pBaseDirPath, const wchar_t* pRelPath, Mix::StringW& outPath );
}

//! @namespace Mix::Memory
//! @brief 
namespace Mix{ namespace Memory{

	class IBuffer;

}}

//! @namespace Mix::File
//! @brief t@C
namespace Mix{ namespace File{

	class IManager;
	class IReader;
	class IWriter;
	class ILoader;
	class ILoaderCallback;

	//! @enum DIRECTORY_IDENT
	//! @brief fBNgʎq񋓒萔
	enum DIRECTORY_IDENT
	{
		DIRECTORY_IDENT_ROOT		= 0,	//!< [g
		DIRECTORY_IDENT_USER		= 1,	//!< [U[( }ChLg Mix::ENGINECONFIG::file::pUserDirectoryName )
		DIRECTORY_IDENT_APPDATA		= 2,	//!< AvP[Vf[^
		DIRECTORY_IDENT_DESKTOP		= 3,	//!< fXNgbv
		DIRECTORY_IDENT_MYDOCUMENT	= 4,	//!< }ChLg
	};

	//! @enum SEEK_METHOD
	//! @brief V[N񋓒萔
	enum SEEK_METHOD
	{
		SEEK_METHOD_BEGIN	= 0,	//!< t@C̐擪V[N
		SEEK_METHOD_CURRENT	= 1,	//!< t@C݈ʒuV[N
		SEEK_METHOD_END		= 2,	//!< t@C̏I[V[N
	};

	//! @brief }l[W̃|C^擾܂
	//! @return }l[W\ Mix::File::IManager C^[tF[X̃|C^Ԃ܂
	_MIX_DLL_API Mix::File::IManager* GetManagerPtr( void );
	//! @brief }l[W擾܂
	//! @param[out] ppManager }l[W\ Mix::File::IManager C^[tF[X̃|C^̃AhX
	//! @return ꍇ True Ԃ܂
	//! @note 擾}l[W͎QƃJE^ +1 ܂B
	_MIX_DLL_API Boolean GetManager( Mix::File::IManager** ppManager );
}}

//! @namespace Mix::Input
//! @brief Cvbg
namespace Mix{ namespace Input{

	class IManager;
	class IKeyboard;
	class IMouse;
	class IGamepad;

	//! @enum KEY
	//! @brief L[Xg
	enum KEY
	{
		KEY_F1			= 1,	//!< F1
		KEY_F2			= 2,	//!< F2 
		KEY_F3			= 3,	//!< F3
		KEY_F4			= 4,	//!< F4
		KEY_F5			= 5,	//!< F5
		KEY_F6			= 6,	//!< F6
		KEY_F7			= 7,	//!< F7
		KEY_F8			= 8,	//!< F8
		KEY_F9			= 9,	//!< F9
		KEY_F10			= 10,	//!< F10
		KEY_F11			= 11,	//!< F11
		KEY_F12			= 12,	//!< F12

		KEY_0			= 13,	//!< 0
		KEY_1			= 14,	//!< 1
		KEY_2			= 15,	//!< 2
		KEY_3			= 16,	//!< 3
		KEY_4			= 17,	//!< 4
		KEY_5			= 18,	//!< 5
		KEY_6			= 19,	//!< 6
		KEY_7			= 20,	//!< 7
		KEY_8			= 21,	//!< 8
		KEY_9			= 22,	//!< 9

		KEY_NP0			= 23,	//!< NUMPAD 0
		KEY_NP1			= 24,	//!< NUMPAD 1
		KEY_NP2			= 25,	//!< NUMPAD 2
		KEY_NP3			= 26,	//!< NUMPAD 3
		KEY_NP4			= 27,	//!< NUMPAD 4
		KEY_NP5			= 28,	//!< NUMPAD 5
		KEY_NP6			= 29,	//!< NUMPAD 6
		KEY_NP7			= 30,	//!< NUMPAD 7
		KEY_NP8			= 31,	//!< NUMPAD 8
		KEY_NP9			= 32,	//!< NUMPAD 9

		KEY_A			= 33,	//!< A
		KEY_B			= 34,	//!< B
		KEY_C			= 35,	//!< C
		KEY_D			= 36,	//!< D
		KEY_E			= 37,	//!< E
		KEY_F			= 38,	//!< F
		KEY_G			= 39,	//!< G
		KEY_H			= 40,	//!< H
		KEY_I			= 41,	//!< I
		KEY_J			= 42,	//!< J
		KEY_K			= 43,	//!< K
		KEY_L			= 44,	//!< L
		KEY_M			= 45,	//!< M
		KEY_N			= 46,	//!< N
		KEY_O			= 47,	//!< O
		KEY_P			= 48,	//!< P
		KEY_Q			= 49,	//!< Q
		KEY_R			= 50,	//!< R
		KEY_S			= 51,	//!< S
		KEY_T			= 52,	//!< T
		KEY_U			= 53,	//!< U
		KEY_V			= 54,	//!< V
		KEY_W			= 55,	//!< W
		KEY_X			= 56,	//!< X
		KEY_Y			= 57,	//!< Y
		KEY_Z			= 58,	//!< Z

		KEY_UP			= 59,	//!< 
		KEY_DOWN		= 60,	//!< 
		KEY_LEFT		= 61,	//!< 
		KEY_RIGHT		= 62,	//!< 

		KEY_ESCAPE		= 63,	//!< ESC
		KEY_TAB			= 64,	//!< TAB
		KEY_BACKSPACE	= 65,	//!< BACKSPACE
		KEY_DELETE		= 66,	//!< DEL
		KEY_SPACE		= 67,	//!< SPACE
		KEY_RETURN		= 68,	//!< RETURN( ENTER )
		KEY_SHIFT		= 69,	//!< SHIFT
		KEY_LSHIFT		= 70,	//!< SHIFT
		KEY_RSHIFT		= 71,	//!< ESHIFT
		KEY_CTRL		= 72,	//!< CTRL
		KEY_LCTRL		= 73,	//!< CTRL
		KEY_RCTRL		= 74,	//!< ECTRL
		KEY_ALT			= 75,	//!< ALT
		KEY_LALT		= 76,	//!< ALT
		KEY_RALT		= 77,	//!< EALT

		KEY_MAX			= 78,	//!< L[̍ő吔
	};

	//! @enum GAMEPAD_API
	//! @brief Q[pbhAPI񋓒萔
	enum GAMEPAD_API
	{
		GAMEPAD_UNKNOWN		= 0,	//!< s
		GAMEPAD_XINPUT		= 1,	//!< XInput
		GAMEPAD_DIRECTINPUT	= 2,	//!< DirectInput
	};

	//! @enum GAMEPAD_CONSTANT
	//! @brief Q[pbh萔񋓒萔
	enum GAMEPAD_CONSTANT
	{
		GAMEPAD_TRIGGER_RESOLUTION	= 255,		//!< gK[̉𑜓x
		GAMEPAD_STICK_RESOLUTION	= 32767,	//!< XeBbN̉𑜓x

		GAMEPAD_LEFT				= 0,		//!< 
		GAMEPAD_RIGHT				= 1,		//!< E
	};

	//! @enum GAMEPAD_PORT
	//! @brief Q[pbh|[g񋓒萔
	enum GAMEPAD_PORT
	{
		GAMEPAD_XI_A		= 0,	//!< XInputQ[pbhA
		GAMEPAD_XI_B		= 1,	//!< XInputQ[pbhB
		GAMEPAD_XI_C		= 2,	//!< XInputQ[pbhC
		GAMEPAD_XI_D		= 3,	//!< XInputQ[pbhD

		GAMEPAD_DI_A		= 4,	//!< DirectInputQ[pbhA
		GAMEPAD_DI_B		= 5,	//!< DirectInputQ[pbhB
		GAMEPAD_DI_C		= 6,	//!< DirectInputQ[pbhC
		GAMEPAD_DI_D		= 7,	//!< DirectInputQ[pbhD

		GAMEPAD_PORT_MAX	= 8,	//!< Q[|[g̍ő吔
	};

	//! @enum GAMEPAD_BUTTON
	//! @brief Q[pbh{^񋓒萔
	enum GAMEPAD_BUTTON
	{
		GAMEPAD_POV_UP			= 0,	//!< POV(  )
		GAMEPAD_POV_DOWN		= 1,	//!< POV(  )
		GAMEPAD_POV_LEFT		= 2,	//!< POV(  )
		GAMEPAD_POV_RIGHT		= 3,	//!< POV( E )
		GAMEPAD_START			= 4,	//!< X^[g
		GAMEPAD_BACK			= 5,	//!< obN
		GAMEPAD_STICK_LEFT		= 6,	//!< XeBbN(  )
		GAMEPAD_STICK_RIGHT		= 7,	//!< XeBbN( E )
		GAMEPAD_SHOULDER_LEFT	= 8,	//!< V_[(  )
		GAMEPAD_SHOULDER_RIGHT	= 9,	//!< V_[( E )
		GAMEPAD_A				= 10,	//!< A
		GAMEPAD_B				= 11,	//!< B
		GAMEPAD_X				= 12,	//!< X
		GAMEPAD_Y				= 13,	//!< Y

		GAMEPAD_BUTTON_MAX		= 14,	//!< {^̍ő吔
	};

	//! @enum SWITCH_STATE
	//! @brief XCb`Xe[g񋓒萔
	enum SWITCH_STATE
	{
		PRESSED			= 0x00000001,		//!< L[A{^ꂽ
		RELEASED		= 0x00000002,		//!< L[A{^ꂽ
		DOWN			= 0x00000004,		//!< L[A{^Ă
	};

	//! @brief }l[W̃|C^擾܂
	//! @return }l[W\ Mix::Input::IManager C^[tF[X̃|C^Ԃ܂
	_MIX_DLL_API Mix::Input::IManager* GetManagerPtr( void );
	//! @brief }l[W擾܂
	//! @param[out] ppManager }l[W\ Mix::Input::IManager C^[tF[X̃|C^̃AhX
	//! @return ꍇ True Ԃ܂
	//! @note 擾}l[W͎QƃJE^ +1 ܂B
	_MIX_DLL_API Boolean GetManager( Mix::Input::IManager** ppManager );
}}

//! @namespace Mix::Dynamics
//! @brief _Ci~NX
namespace Mix{ namespace Dynamics{

	class IManager;
	class IShape;
	class ISphereShape;
	class IBoxShape;
	class IConeShape;
	class ICapsuleShape;
	class ICylinderShape;
	class IConvexHullShape;
	class ICompoundShape;
	class IJoint;
	class IPointJoint;
	class IHingeJoint;
	class ISliderJoint;
	class IDofJoint;
	class IBallJoint;
	class IWorld;
	class IObject;
	class IObjectListener;
	class IObjectDragger;
	class ISimpleObject;
	class IStaticPlane;
	class IStaticMesh;
	class IRigidBody;
	class ISensor;
	class IKinematicCharacter;
	class IVehicle;
	class IVehicleWheel;

	//! @enum AXIS_TYPE
	//! @brief ^Cv񋓒萔
	enum AXIS_TYPE
	{
		AXIS_X = 0,	//!< X
		AXIS_Y = 1,	//!< Y
		AXIS_Z = 2,	//!< Z
	};

	//! @enum OBJECT_FILTER_FLAG
	//! @brief IuWFNgtB^[tO񋓒萔
	enum OBJECT_FILTER_FLAG
	{
		OF_DEFAULT			= 0x0001,	//!< ftHg
		OF_STATIC			= 0x0002,	//!< X^eBbN
		OF_KINEMATIC		= 0x0004,	//!< Ll}eBbN
		OF_DEBRIS			= 0x0008,	//!< fu
		OF_SENSOR			= 0x0010,	//!< ZT[
		OF_CHARACTER		= 0x0020,	//!< LN^[

		//! @brief S
		OF_ALL				= ( OF_DEFAULT | OF_STATIC | OF_KINEMATIC | OF_DEBRIS | OF_SENSOR | OF_CHARACTER ),

		//! @brief ftHgtB^[}XN
		OF_DEFAULT_MASK		= ( OF_DEFAULT | OF_STATIC | OF_KINEMATIC | OF_SENSOR ),
		//! @brief X^eBbNtB^[}XN
		OF_STATIC_MASK		= ( OF_DEFAULT | OF_KINEMATIC | OF_DEBRIS | OF_SENSOR | OF_CHARACTER ),
		//! @brief Ll}eBbNtB^[}XN
		OF_KINEMATIC_MASK	= ( OF_DEFAULT | OF_SENSOR ),
		//! @brief futB^[}XN
		OF_DEBRIS_MASK		= ( OF_STATIC ),
		//! @brief ZT[tB^[}XN
		OF_SENSOR_MASK		= ( OF_DEFAULT | OF_STATIC | OF_KINEMATIC ),
		//! @brief LN^[tB^[}XN
		OF_CHARACTER_MASK	= ( OF_STATIC | OF_CHARACTER ),
	};

	//! @enum DEBUG_DRAW_FLAG
	//! @brief fobO`̃tO񋓒萔
	enum DEBUG_DRAW_FLAG
	{
		DD_WIREFRAME	= 0x00000001,	//!< C[t[(Wbh{fBAZT[ALl}eBbNLN^[)
		DD_AXIS			= 0x00000002,	//!< ( Wbh{fB )
		DD_JOINT_FRAME	= 0x00000004,	//!< WCg̃t[
		DD_JOINT_LIMIT	= 0x00000008,	//!< WCg̃~bg
	};

	//! @enum DEBUG_DRAW_COLOR_TYPE
	//! @brief fobO`̃J[^Cv񋓒萔
	enum DEBUG_DRAW_COLOR_TYPE
	{
		DDC_RIGIDBODY_AROUSAL		= 0,	//!< Wbh{fB : Ɋ
		DDC_RIGIDBODY_ACTIVE		= 1,	//!< Wbh{fB : 
		DDC_RIGIDBODY_SLEEPY		= 2,	//!< Wbh{fB : x~ɂȂȌ
		DDC_RIGIDBODY_REST			= 3,	//!< Wbh{fB : x~
		DDC_RIGIDBODY_DISABLE		= 4,	//!< Wbh{fB : ( V~[V͍sĂȂ )

		DDC_SENSOR					= 5,	//!< ZT[

		DDC_KINEMATIC_CHARACTER		= 6,	//!< Ll}eBbNLN^[

		DDC_JOINT_FRAME				= 7,	//!< WCg : t[
		DDC_JOINT_LIMIT				= 8,	//!< WCg : ~bg
	};

	//! @struct MATERIAL
	//! @brief }eA\
	struct MATERIAL
	{
		UInt32 id;				//!< ʎq
		UInt32 attr;			//!< 
		Float32 friction;		//!< CW
		Float32 restitution;	//!< W

		//! @brief RXgN^
		MATERIAL( void )
		{
			id = 0;
			attr = 0;
			friction = 0.5f;
			restitution = 0.0f;
		}

		//! @brief RXgN^
		//! @param[in] _id ʎq
		//! @param[in] _attr 
		MATERIAL( UInt32 _id, UInt32 _attr )
		{
			id = _id;
			attr = _attr;
			friction = 0.5f;
			restitution = 0.0f;
		}

		//! @brief RXgN^
		//! @param[in] _id ʎq
		//! @param[in] _attr 
		//! @param[in] _friction CW
		//! @param[in] _restitution W
		MATERIAL( UInt32 _id, UInt32 _attr, Float32 _friction, Float32 _restitution )
		{
			id = _id;
			attr = _attr;
			friction = _friction;
			restitution = _restitution;
		}
	};

	//! @struct MESH
	//! @brief bV\
	struct MESH
	{
		//! @brief _
		UInt32 vertexCount;

		//! @brief _Xg
		const Mix::Vector3* vertices;

		//! @brief |S
		UInt32 polygonCount;

		//! @brief |S̃CfbNXXg
		//! @note
		//! _̎QƗpCfbNXzɂȂ܂B<br>
		//! |S * 3 ̗vfzpӂKv܂( Op`Ŏw肷Kv邱ƂӖ܂ )B
		const UInt32* polygonIndices;
	};

	//! @struct MANIFOLD_MESH
	//! @brief }jtH[hbV\
	struct MANIFOLD_MESH
	{
		//! @brief p[gCfbNX
		//! @note X^eBbNbV쐬ۂɓn Mix::Dynamics::MESH z̃CfbNXɂȂ܂
		UInt32 partIndex;

		//! @brief |S̃CfbNX
		UInt32 polygonIndex;
	};

	//! @struct MANIFOLD_POINT
	//! @brief }jtH[h|Cg\
	struct MANIFOLD_POINT
	{
		Mix::Vector3 localPositionA;				//!< g : ڐGʒũ[JW
		Mix::Vector3 localPositionB;				//!<  : ڐGʒũ[JW

		Mix::Vector3 worldPositionA;				//!< g : ڐGʒũ[hW
		Mix::Vector3 worldPositionB;				//!<  : ڐGʒũ[hW

		Mix::Vector3 worldNormalB;					//!<  : ڐGʒũ[h@

		Mix::Dynamics::MATERIAL materialA;			//!< g : ڐGʒũ}eA
		Mix::Dynamics::MATERIAL materialB;			//!<  : ڐGʒũ}eA

		Mix::Dynamics::MANIFOLD_MESH meshA;			//!< g : bV
		Mix::Dynamics::MANIFOLD_MESH meshB;			//!<  : bV

		Float32 penetrationB;						//!< ߂荞ł鋗

		Float32 impulse;							//!< 

		Float32 combinedFriction;					//!< CW
		Float32 combinedRestitution;				//!< W
	};

	//! @struct MANIFOLD
	//! @brief }jtH[h\
	struct MANIFOLD
	{
		Mix::Dynamics::IObject* pObjectB;				//!< ڐGĂIuWFNg\ Mix::Dynamics::IObject C^[tF[X̃|C^

		UInt32 pointCount;								//!< |Cg̐
		const Mix::Dynamics::MANIFOLD_POINT* points;	//!< |CgXg
	};

	//! @struct TEST_LOCAL_RESULT
	//! @brief [J̌茋ʍ\
	struct TEST_LOCAL_RESULT
	{
		Mix::Vector3 pos;						//!< ڐGW
		Mix::Vector3 normal;					//!< ڐGĂW̖@
	};

	//! @struct VEHICLE_WHEEL_DESC
	//! @brief rnCNzC[\
	struct VEHICLE_WHEEL_DESC
	{
		Boolean bFront;					//!< tg̏ꍇ True
		Mix::Vector3 direction;			//!< 
		Mix::Vector3 axis;				//!< Vtg̎
		Mix::Vector3 connectionPoint;	//!< ڑʒu
		Float32 tireRadius;				//!< ^C̔a
		Float32 suspensionRestLength;	//!< TXyV̒
	};

	//! @struct DEBUG_WORLD_PROFILE
	//! @brief fobO : [hvt@C
	struct DEBUG_WORLD_PROFILE
	{
		Float32 ssElapsedTime;	//!< V~[Vɂ( bP )
		Float32 cpElapsedTime;	//!< ڐG̎Wɂ( bP )
	};

	//! @brief }l[W̃|C^擾܂
	//! @return }l[W\ Mix::Dynamics::IManager C^[tF[X̃|C^Ԃ܂
	_MIX_DLL_API Mix::Dynamics::IManager* GetManagerPtr( void );
	//! @brief }l[W擾܂
	//! @param[out] ppManager }l[W\ Mix::Dynamics::IManager C^[tF[X̃|C^̃AhX
	//! @return ꍇ True Ԃ܂
	//! @note 擾}l[W͎QƃJE^ +1 ܂B
	_MIX_DLL_API Boolean GetManager( Mix::Dynamics::IManager** ppManager );
}}

//! @namespace Mix::Graphics
//! @brief OtBbNX
namespace Mix{ namespace Graphics{

	class IManager;
	class IDevice;
	class IVertexLayout;
	class IHullShader;
	class IDomainShader;
	class IGeometryShader;
	class IVertexShader;
	class IPixelShader;
	class IShaderConstant;
	class IVertexBuffer;
	class IIndexBuffer;
	class ITexture;
	class IQuery;

	//! @enum SHADER_MODEL
	//! @brief VF[_[f񋓒萔
	enum SHADER_MODEL
	{
		SHADER_MODEL_3	= 0,	//!< VF[_[f 3.0( DirectX9 )
		SHADER_MODEL_4	= 1,	//!< VF[_[f 4.0( DirectX10 )
		SHADER_MODEL_5	= 2,	//!< VF[_[f 5.0( DirectX11 )
	};

	//! @enum VERTEX_ELEMENT_SEMANTIC
	//! @brief o[ebNXGgZ}eBbN񋓒萔
	enum VERTEX_ELEMENT_SEMANTIC
	{
		VLS_POSITION		= 0,	//!< W( Float32[4] )
		VLS_BLENDWEIGHT		= 1,	//!< uh̏d( Float32 )
		VLS_BLENDINDICES	= 2,	//!< uhCfbNX( UInt32[n] )
		VLS_NORMAL			= 3,	//!< @( Float32[4] )
		VLS_PSIZE			= 4,	//!< |CgTCY( Float32[n] )
		VLS_TEXTURE			= 5,	//!< eNX`W( Float32[4] )
		VLS_TANGENT			= 6,	//!< ڐ( Float32[4] )
		VLS_BINORMAL		= 7,	//!< ]@( Float32[4] )
		VLS_COLOR			= 8,	//!< J[( Float32[4] )
	};

	//! @enum VERTEX_ELEMENT_FORMAT
	//! @brief o[ebNXGgtH[}bg񋓒萔
	enum VERTEX_ELEMENT_FORMAT
	{
		VLF_FLOAT32_1	= 0,	//!< 1A32rbg_
		VLF_FLOAT32_2	= 1,	//!< 2A32rbg_
		VLF_FLOAT32_3	= 2,	//!< 3A32rbg_
		VLF_FLOAT32_4	= 3,	//!< 4A32rbg_
		VLF_UINT8_4		= 4,	//!< 4A8rbgȂ
		VLF_INT16_2		= 5,	//!< 2A16rbg萮
		VLF_INT16_4		= 6,	//!< 4A16rbg萮
		VLF_UINT8_4N	= 7,	//!< 4A8rbgȂ( K )
		VLF_INT16_2N	= 8,	//!< 2A16rbg萮( K )
		VLF_INT16_4N	= 9,	//!< 4A16rbg萮( K )
		VLF_UINT16_2N	= 10,	//!< 2A16rbgȂ( K )
		VLF_UINT16_4N	= 11,	//!< 4A16rbgȂ( K )
		VLF_FLOAT16_2	= 12,	//!< 2A16rbg_
		VLF_FLOAT16_4	= 13,	//!< 4A16rbg_
	};

	//! @enum SHADER_TARGET
	//! @brief VF[_[^[Qbg񋓒萔
	enum SHADER_TARGET
	{
		VS_3_0	= 0,	//!< o[ebNXVF[_[ 3.0
		PS_3_0	= 1,	//!< sNZVF[_[ 3.0

		CS_4_0	= 2,	//!< Rs[gVF[_[ 4.0
		GS_4_0	= 3,	//!< WIgVF[_[ 4.0
		VS_4_0	= 4,	//!< o[ebNXVF[_[ 4.0
		PS_4_0	= 5,	//!< sNZVF[_[ 4.0

		CS_4_1	= 6,	//!< Rs[gVF[_[ 4.1
		GS_4_1	= 7,	//!< WIgVF[_[ 4.1
		VS_4_1	= 8,	//!< o[ebNXVF[_[ 4.1
		PS_4_1	= 9,	//!< sNZVF[_[ 4.1

		CS_5_0	= 10,	//!< Rs[gVF[_[ 5.0
		DS_5_0	= 11,	//!< hCVF[_[ 5.0
		GS_5_0	= 12,	//!< WIgVF[_[ 5.0
		HS_5_0	= 13,	//!< nVF[_[ 5.0
		VS_5_0	= 14,	//!< o[ebNXVF[_[ 5.0
		PS_5_0	= 15,	//!< sNZVF[_[ 5.0
	};

	//! @struct SHADER_MACRO
	//! @brief VF[_[}N\
	struct SHADER_MACRO
	{
		const char* pNameA;	//!< O
		const char* pDefA;	//!< `
	};

	//! @enum FILL_TYPE
	//! @brief `^Cv񋓒萔
	enum FILL_TYPE
	{
		FILL_WIREFRAME	= 0,	//!< C[t[
		FILL_SOLID		= 1,	//!< \bh
	};

	//! @enum CULL_TYPE
	//! @brief JO^Cv񋓒萔
	enum CULL_TYPE
	{
		CULL_NONE	= 0,	//!< SĂ̎Op``悵܂
		CULL_FRONT	= 1,	//!< O̎Op``悵܂
		CULL_BACK	= 2,	//!< ̎Op``悵܂
	};

	//! @enum BLEND_TYPE
	//! @brief uh^Cv񋓒萔
	enum BLEND_TYPE
	{
		BLEND_COPY		= 0,	//!< Rs[
		BLEND_NORMAL	= 1,	//!< ʏ
		BLEND_ADD		= 2,	//!< Z
		BLEND_SUB		= 3,	//!< Z
		BLEND_MUL		= 4,	//!< Z
		BLEND_SCREEN	= 5,	//!< XN[
	};

	//! @enum ZFUNC_TYPE
	//! @brief Zt@NV񋓒萔
	enum ZFUNC_TYPE
	{
		ZFUNC_ALWAYS		= 0,	//!< ɐ
		ZFUNC_NEVER			= 1,	//!< Ɏs
		ZFUNC_LESS			= 2,	//!< VsNZ݂̃sNZ菬ɉ
		ZFUNC_EQUAL			= 3,	//!< VsNZ݂̃sNZƓɉ
		ZFUNC_LESSEQUAL		= 4,	//!< VsNZlÃ݂sNZlȉ̂Ƃɉ
		ZFUNC_GREATER		= 5,	//!< VsNZlÃ݂sNZl傫Ƃɉ
		ZFUNC_NOTEQUAL		= 6,	//!< VsNZlÃ݂sNZlƓȂƂɉ
		ZFUNC_GREATEREQUAL	= 7,	//!< VsNZlÃ݂sNZlȏ̂Ƃɉ
	};

	//! @enum TEXTURE_TYPE
	//! @brief eNX`^Cv񋓒萔
	enum TEXTURE_TYPE
	{
		TEXTURE_2D		= 0,	//!< 2DeNX`
		TEXTURE_CUBE	= 1,	//!< L[ueNX`
		TEXTURE_TARGET	= 2,	//!< ^[QbgeNX`
		TEXTURE_DEPTH	= 3,	//!< fvXeNX`
	};

	//! @enum TEXTURE_FILTER_TYPE
	//! @brief eNX`tB^^Cv񋓒萔
	enum TEXTURE_FILTER_TYPE
	{
		TEXTURE_FILTER_POINT		= 0,	//!< |CgtB^
		TEXTURE_FILTER_LINEAR		= 1,	//!< jAtB^( ` )
		TEXTURE_FILTER_ANISOTROPIC	= 2,	//!< Aj\gsbNtB^( ٕ )
	};

	//! @enum TEXTURE_ADDRESS_TYPE
	//! @brief eNX`[W̉@񋓒萔
	enum TEXTURE_ADDRESS_TYPE
	{
		TEXTURE_ADDRESS_WRAP		= 0,	//!< ؂育ƂɃeNX`[JԂ܂
		TEXTURE_ADDRESS_CLAMP	= 1,	//!< ؂育ƂɃeNX`[𔽓]܂
	};

	//! @enum CUBEMAP_FACE
	//! @brief L[u}bṽtFCX񋓒萔
	enum CUBEMAP_FACE
	{
		CUBEMAP_FACE_POSITIVE_X = 0,	//!< ̂w
		CUBEMAP_FACE_NEGATIVE_X = 1,	//!< ̂w
		CUBEMAP_FACE_POSITIVE_Y = 2,	//!< ̂x
		CUBEMAP_FACE_NEGATIVE_Y = 3,	//!< ̂x
		CUBEMAP_FACE_POSITIVE_Z = 4,	//!< ̂y
		CUBEMAP_FACE_NEGATIVE_Z = 5,	//!< ̂y
	};

	//! @enum FORMAT
	//! @brief tH[}bg񋓒萔
	enum FORMAT
	{
		FMT_UNKNOWN			= 0,	//!< sȃtH[}bg

		FMT_D16				= 1,	//!< 1AfvX`l16rbgtH[}bg
		FMT_D32				= 2,	//!< 1AfvX`l32rbgtH[}bg
		FMT_D24S8			= 3,	//!< 2AfvX`l24rbg XeV`l8rbgtH[}bg

		FMT_R8G8B8A8		= 4,	//!< 4A32rbgtH[}bg
		FMT_A8				= 5,	//!< 1A8rbgtH[}bg
		FMT_R16F			= 6,	//!< 1A16rbg_tH[}bg
		FMT_R32F			= 7,	//!< 1A32rbg_tH[}bg
		FMT_R16G16F			= 8,	//!< 2A16rbg_tH[}bg
		FMT_R32G32F			= 9,	//!< 2A32rbg_tH[}bg
		FMT_R16G16B16A16F	= 10,	//!< 4A64rbg_tH[}bg
		FMT_R32G32B32A32F	= 11,	//!< 4A128rbg_tH[}bg

		FMT_DXT1			= 12,	//!< DXT1ktH[}bg
		FMT_DXT2			= 13,	//!< DXT2ktH[}bg
		FMT_DXT3			= 14,	//!< DXT3ktH[}bg
		FMT_DXT4			= 15,	//!< DXT4ktH[}bg
		FMT_DXT5			= 16,	//!< DXT5ktH[}bg
	};

	//! @enum INDEX_TYPE
	//! @brief CfbNX^Cv񋓒萔
	enum INDEX_TYPE
	{
		INDEX_USHORT	= 0,	//!< 16BitCfbNXobt@
		INDEX_UINT		= 1,	//!< 32BitCfbNXobt@
	};

	//! @enum PRIMITIVE_TYPE
	//! @brief v~eBu^Cv񋓒萔
	enum PRIMITIVE_TYPE
	{
		PRIMITIVE_POINTLIST		= 0,	//!< |CgXg
		PRIMITIVE_LINELIST		= 1,	//!< CXg
		PRIMITIVE_LINESTRIP		= 2,	//!< CXgbv
		PRIMITIVE_TRIANGLELIST	= 3,	//!< gCAOXg
		PRIMITIVE_TRIANGLESTRIP	= 4,	//!< gCAOXgbv
	};

	//! @enum QUERY_TYPE
	//! @brief NG^Cv񋓒萔
	enum QUERY_TYPE
	{
		QUERY_EVENT		= 0,	//!< Cxg
		QUERY_OCCLUSION	= 1,	//!< IN[W
	};

	//! @enum COLOR_WRITE_MASK
	//! @brief J[݃}XN񋓒萔
	enum COLOR_WRITE_MASK
	{
		COLOR_WRITE_RGBA	= 0,	//!< Sď
		COLOR_WRITE_RGB		= 1,	//!< RGB̂ݏ
		COLOR_WRITE_A		= 2,	//!< At@̂ݏ
	};

	//! @struct VERTEX_ELEMENT
	//! @brief o[ebNXGg\
	struct VERTEX_ELEMENT
	{
		UInt32 semanticType;	//!< Z}eBbN^Cv( Mix::Graphics::VERTEX_ELEMENT_SEMANTIC )
		UInt32 semanticIndex;	//!< Z}eBbNCfbNX
		UInt32 format;			//!< tH[}bg( Mix::Graphics::VERTEX_ELEMENT_FORMAT )
		UInt32 offset;			//!< ItZbg
	};

	//! @struct RASTERIZER_DESC
	//! @brief X^CUXe[g\
	struct RASTERIZER_DESC
	{
		Mix::Graphics::FILL_TYPE fillMode;	//!< tB[h
		Mix::Graphics::CULL_TYPE cullMode;	//!< JO[h
		Boolean bScissoring;				//!< VUOLɂꍇ True
		Boolean bMultisample;				//!< }`TvLɂꍇ True
	};

	//! @struct DEPTH_DESC
	//! @brief fvXXe[g\
	struct DEPTH_DESC
	{
		Boolean bTest;					//!< ZeXgLɂꍇ True
		Boolean bWrite;					//!< Zl݂̏Lɂꍇ True
		Mix::Graphics::ZFUNC_TYPE func;	//!< ZeXgɎgpt@NV
	};

	//! @struct BLEND_DESC
	//! @brief uhXe[g\
	struct BLEND_DESC
	{
		Mix::Graphics::BLEND_TYPE type;					//!< ^Cv
		Mix::Graphics::COLOR_WRITE_MASK colorWriteMask;	//!< J[̏݃}XN\ Mix::Graphics::COLOR_WRITE_MASK 񋓒萔
	};

	//! @struct TEXTURE_LOCK_INFO
	//! @brief eNX`bN\
	struct TEXTURE_LOCK_INFO
	{
		UInt32 pitch;	//!< eNX`̃sb`( oCgP )
		void* bits;		//!< bNeNX`ւ̃|C^
	};

	//! @brief }l[W̃|C^擾܂
	//! @return }l[W\ Mix::Graphics::IManager C^[tF[X̃|C^Ԃ܂
	_MIX_DLL_API Mix::Graphics::IManager* GetManagerPtr( void );
	//! @brief }l[W擾܂
	//! @param[out] ppManager }l[W\ Mix::Graphics::IManager C^[tF[X̃|C^̃AhX
	//! @return ꍇ True Ԃ܂
	//! @note 擾}l[W͎QƃJE^ +1 ܂B
	_MIX_DLL_API Boolean GetManager( Mix::Graphics::IManager** ppManager );
}}

//! @namespace Mix::Graphics::Utility
//! @brief OtBbNX[eBeB
namespace Mix{ namespace Graphics{ namespace Utility{

	class ITargetTextureChain;
	class IFont;
	class IText;
	class ILineArt;
	class ICanvas;

}}}

//! @namespace Mix::Geometry
//! @brief WIg
namespace Mix{ namespace Geometry{}}

//! @namespace Mix::Sound
//! @brief TEh
namespace Mix{ namespace Sound{

	class IManager;
	class IDevice;
	class IController;
	class IEmitter;
	class IListener;

	//! @brief }l[W̃|C^擾܂
	//! @return }l[W\ Mix::Sound::IManager C^[tF[X̃|C^Ԃ܂
	_MIX_DLL_API Mix::Sound::IManager* GetManagerPtr( void );
	//! @brief }l[W擾܂
	//! @param[out] ppManager }l[W\ Mix::Sound::IManager C^[tF[X̃|C^̃AhX
	//! @return ꍇ True Ԃ܂
	//! @note 擾}l[W͎QƃJE^ +1 ܂B
	_MIX_DLL_API Boolean GetManager( Mix::Sound::IManager** ppManager );

}}

//! @namespace Mix::Network
//! @brief lbg[N
namespace Mix{ namespace Network{

	class IManager;
	class ITcpServer;
	class ITcpServerCallback;
	class ISession;
	class IPacketSender;
	class ITcpClient;
	class ITcpClientCallback;

	//! @enum RESULT
	//! @brief lbg[NɊւ郁\bhԂl̃Xg
	enum RESULT
	{
		OK					= 0,	//!< G[͔ĂȂ
		ERR_FATAL			= -1,	//!< vIȃG[
		ERR_SERVER_NOTFOUND	= -2,	//!< ڑT[o[Ȃ
		ERR_TIMEOUT			= -3,	//!< ^CAEg
		ERR_WAITEVENT		= -4,	//!< Cxgҋ@ɃG[
		ERR_ENUMEVENT		= -5,	//!< Cxg^Cv̓蒆ɃG[
		ERR_SEND			= -6,	//!< pPbg̑MɎs
		ERR_RECIVE			= -7,	//!< pPbg̎MɎs
		ERR_BLOKENPACKET	= -8,	//!< pPbgjĂ
		ERR_LARGEPACKETSIZE	= -9,	//!< pPbg傫
	};

	//! @enum PROTOCOL
	//! @brief vgR
	enum PROTOCOL
	{
		TCP = 0,	//!< TCP
		UDP = 1,	//!< UDP
	};

	//! @struct TCP_CLIENTCONFIG
	//! @brief TCPNCAg̐ݒ\
	//! @note
	//! <b> uMobt@vɂ</b><br>
	//! <br>
	//! uMobt@v( ȍ~ obt@ )̓pPbgTCY菬TCYw肷邱Ƃł܂A<br>
	//! obt@TCY𒴂pPbg𑗐M悤ƂہAɕđM邱ƂɂȂ܂B<br>
	//! x^ɂȂƁAɂȂ܂őҋ@邽߁AptH[}XɈeyڂ܂B<br>
	//! obt@TCY͈ȉ̂悤Ɏw肵ĂB<br>
	//! <br>
	//! obt@TCY = ( ( pPbgTCY + 16  ) * xɑMłpPbg ) byte<br>
	//! <br>
	//! <br>
	//! <b>uMobt@vuMe|obt@vɂ</b><br>
	//! <br>
	//! pPbgMہAꎞIɁuMe|obt@vɊi[A<br>
	//! pPbgSȏԂɂȂAuMobt@vփRs[܂B<br>
	//! <br>
	//! ȏ̂Ƃȉ̐񂪂܂B<br>
	//! <br>
	//! uMobt@v           : uMe|obt@v傫 obt@TCY = ( ( pPbgTCY + 8  ) * xɊi[łpPbg ) byte<br>
	//! uMe|obt@v : pPbgTCY傫 obt@TCY = ( ( pPbgTCY + 16  ) * xɊi[łpPbg ) byte<br>
	//! <br>
	//!  Mɕtꂽ
	struct TCP_CLIENTCONFIG
	{
		UInt16 port;									//!< gp|[g
		const wchar_t* pServerIPAddr;					//!< ڑT[o[IPAhX
		Mix::Network::ITcpClientCallback* pCallback;	//!< R[obÑ|C^
		Boolean bUseNagle;								//!< NagleASYgp邩ǂ( ʏ True w肵Ă )
		UInt32 timeOut;									//!< ^CAEg( 1/1000bP )
		UInt32 sleepTime;								//!< Xbh̃X[v( 1/1000bP )
		UInt32 sendBuffSize;							//!< Mobt@̃TCY
		UInt32 receiveBuffSize;							//!< Mobt@̃TCY
		UInt32 receiveTempBuffSize;						//!< Me|obt@̃TCY
	};

	//! @struct TCP_SERVERCONFIG
	//! @brief TCPT[o[̐ݒ\
	//! @note ZbV́uMobt@vuMobt@vuMe|obt@vɂẮAMix::Network::TCP_CLIENTCONFIG QƂĂB
	struct TCP_SERVERCONFIG
	{
		UInt16 port;									//!< gp|[g
		UInt32 maxConnection;							//!< ő哯ڑ
		Mix::Network::ITcpServerCallback* pCallback;	//!< R[obÑ|C^
		UInt32 echoInterval;							//!< ʐMԂmF邽߂̃GR[̑MԊu( 1/1000bP )
		UInt32 timeOut;									//!< ^CAEg( 1/1000bP )
		UInt32 sleepTime;								//!< Xbh̃X[v( 1/1000bP )
		UInt32 sendBuffSize;							//!< ZbV̑Mobt@̃TCY
		UInt32 receiveBuffSize;							//!< ZbV̎Mobt@̃TCY
		UInt32 receiveTempBuffSize;						//!< ZbV̎Me|obt@̃TCY
	};

	//! @brief }l[W̃|C^擾܂
	//! @return }l[W\ Mix::Network::IManager C^[tF[X̃|C^Ԃ܂
	_MIX_DLL_API Mix::Network::IManager* GetManagerPtr( void );
	//! @brief }l[W擾܂
	//! @param[out] ppManager }l[W\ Mix::Network::IManager C^[tF[X̃|C^̃AhX
	//! @return ꍇ True Ԃ܂
	//! @note 擾}l[W͎QƃJE^ +1 ܂B
	_MIX_DLL_API Boolean GetManager( Mix::Network::IManager** ppManager );
}}

//! @namespace Mix::Scene
//! @brief V[
namespace Mix{ namespace Scene{

	class IManager;
	class IFactory;

	class IMaterial;
	class IDefaultMaterial;

	class IMotionMixer;
	class IMotionController;
	class IMotionListener;
	class IMotionState;
	class IMotion;

	class IDynamicsObject;
	class IContactListener;
	class ICollider;
	class ISimpleCollider;
	class ILibertyCollider;
	class IActorCollider;
	class ITerrainCollider;
	class ISensor;
	class IKinematicCharacter;
	class ISimpleKinematicCharacter;
	class IActorKinematicCharacter;

	class IRenderer;
	class IRendererObject;
	class IRendererResource;
	class IEntity;

	class ICamera;
	class IUniversalCamera;
	class IViewCamera;

	class IHemisphereLight;
	class IDirectionalLight;
	class ISpotLight;
	class IPointLight;

	class ISkyDome;
	class IParticle;
	class ILeavingParticle;
	class IScatterParticle;
	class IParticleSystem;
	class IDefaultParticleSystem;
	class IBillboardParticleSystem;
	class IParticleGenerator;
	class IParticleProcessor;
	class IActorModel;
	class IActorListener;
	class IActorNode;
	class IActorConstraint;
	class IActorDynamicsDirector;
	class ITerrainModel;
	class IPlanter;

	class IWaterPool;
	class IWaterPoolContext;

	class IFloor;
	class IGhost;

	class IShadowProjector;
	class ILightShaftsCaster;
	class IAtmosphereScatter;
	class IDynamicsWorld;

	//! @struct MOTION_HANDLE
	//! @brief [Vnh\
	struct _MIX_DLL_API MOTION_HANDLE
	{
		const void* ref0;	//!< ύX֎~I
		const void* ref1;	//!< ύX֎~I

		//! @brief RXgN^
		MOTION_HANDLE( void );
		//! @brief RXgN^
		//! @param[in] value 0
		MOTION_HANDLE( Int32 value );
		//! @brief RXgN^
		//! @param[in] handle nh
		MOTION_HANDLE( const MOTION_HANDLE& handle );
		//! @brief gp֎~
		MOTION_HANDLE( const void* r0, const void* r1 );

		//! @brief nh NULL ɂ܂
		//! @param[in] value  NULL
		//! @return NULL ɂnhԂ܂
		MOTION_HANDLE& operator = ( Int32 value );

		//! @brief Rs[܂
		//! @param[in] handle Rs[̃nh
		//! @return Rs[nhԂ܂
		MOTION_HANDLE& operator = ( const MOTION_HANDLE& handle );

		//! @brief NULLǂmF܂
		//! @param[in] value  NULL
		//! @return NULL ꍇ True Ԃ܂
		Boolean operator == ( Int32 value ) const;
		//! @brief NULLǂmF܂
		//! @param[in] value  NULL
		//! @return NULL ꍇ True Ԃ܂
		Boolean operator != ( Int32 value ) const;

		//! @brief nhǂmF܂
		//! @param[in] handle rnh
		//! @return nh̏ꍇ True Ԃ܂
		Boolean operator == ( const MOTION_HANDLE& handle ) const;
		//! @brief ႤnhǂmF܂
		//! @param[in] handle rnh
		//! @return Ⴄnh̏ꍇ True Ԃ܂
		Boolean operator != ( const MOTION_HANDLE& handle ) const;

		//! @brief p
		bool operator < ( const MOTION_HANDLE& handle ) const;
	};

	//! @enum MOTION_CONSTANT
	//! @brief [V̗񋓒萔
	enum MOTION_CONSTANT
	{
		MOTION_INFINITE_LOOP	= 0xFFFFFFFF,	//!< [v
	};

	//! @enum MOTION_RT_FLAG
	//! @brief [Ṽ[ggXtH[tO񋓒萔
	enum MOTION_RT_FLAG
	{
		MOTION_RT_ROTATION		= 0x00000001,	//!< ]
		MOTION_RT_TRANSLATION	= 0x00000002,	//!< ړ
	};

	//! @enum MOTION_CONDITION_FLAG
	//! @brief [VԃtO񋓒萔
	enum MOTION_CONDITION_FLAG
	{
		//! @brief ҋ@
		//! @note R}hL[̍Ōɂ
		MOTION_COND_WATING		= 0x00000001,

		//! @brief ĐĂ
		//! @note ̃tOP̂Őݒ肳Ăꍇ( MOTION_COND_CURRENT ͐ݒ肳ĂȂ )́A<br>
		//! vrAX[V( gWVIɒ~ԂɂȂ )ɂȂ܂
		MOTION_COND_ACTIVE		= 0x00000002,

		//! @brief Jg[Vł
		//! @note MOTION_COND_ACTIVE ƃyAŐݒ肳܂
		MOTION_COND_CURRENT		= 0x00000004,

		//! @brief ׂẴtO
		MOTION_COND_ALL			= ( MOTION_COND_WATING | MOTION_COND_CURRENT ),

		//! @brief Jg[VƂčĐĂ
		MOTION_COND_CUR_ACTIVE	= ( MOTION_COND_CURRENT | MOTION_COND_ACTIVE ),
	};

	//! @enum MOTION_COMMAND_EXECUTE_TYPE
	//! @brief [VR}hs^Cv񋓒萔
	enum MOTION_COMMAND_EXECUTE_TYPE
	{
		//! @brief xs( ʏ )
		//! @note ҋ@̃R}hSď܂Ŏs܂
		MOTION_CE_DEFAULT	= 0,

		//! @brief s
		//! @note ݑҋ@̃R}hjAgWV̏ImFꎟAs܂
		MOTION_CE_EARLY		= 1,

		//! @brief s
		//! @note ݑҋ@̃R}hjAgWV𒆒fĂAs܂
		MOTION_CE_FORCE		= 2,
	};

	//! @enum MOTION_COMMAND_FLAG
	//! @brief [VR}htO񋓒萔
	enum MOTION_COMMAND_FLAG
	{
		//! @brief [V܂
		MOTION_CF_ACTIVATE				= 0x00000001,

		//! @brief t[( MOTION_COMMAND::frame )Lɂ܂
		MOTION_CF_FRAME					= 0x00000002,
		//! @brief [v( MOTION_COMMAND::loopCount )Lɂ܂
		MOTION_CF_LOOP					= 0x00000004,
		//! @brief gWV( MOTION_COMMAND::transitionTimeLength )Lɂ܂
		MOTION_CF_TRANSITION			= 0x00000008,

		//! @brief t[p܂
		//! @note MOTION_CF_ACTIVATE MOTION_CF_FRAME w肳ĂKv܂
		MOTION_CF_FRAME_INHERIT			= 0x00000010,
		//! @brief [vp܂
		//! @note MOTION_CF_ACTIVATE MOTION_CF_LOOP w肳ĂKv܂
		MOTION_CF_LOOP_INHERIT			= 0x00000020,
		//! @brief gWVp܂
		//! @note MOTION_CF_ACTIVATE MOTION_CF_TRANSITION w肳ĂKv܂
		MOTION_CF_TRANSITION_INHERIT	= 0x00000040,

		//! @brief t[A[vAgWV̑SĂݒ肵܂
		MOTION_CF_SET_ALL				= ( MOTION_CF_FRAME | MOTION_CF_LOOP | MOTION_CF_TRANSITION ),

		//! @brief t[A[vAgWVSĈp܂
		//! @note Đ悤ƂĂ郂[VA݁A풼Õ[VƓꍇɁAp܂B
		MOTION_CF_INHERIT				= ( MOTION_CF_FRAME_INHERIT | MOTION_CF_LOOP_INHERIT | MOTION_CF_TRANSITION_INHERIT ),

		//! @brief t[A[vAgWVݒ肵čĐ
		MOTION_CF_PLAY					= ( MOTION_CF_ACTIVATE | MOTION_CF_SET_ALL ),
		//! @brief t[A[vAgWVݒ肵čĐ( pL )
		MOTION_CF_PLAY_INHERIT			= ( MOTION_CF_ACTIVATE | MOTION_CF_SET_ALL | MOTION_CF_INHERIT ),

		//! @brief gWVݒ肵Ē~
		MOTION_CF_STOP					= ( MOTION_CF_TRANSITION ),
	};

	//! @struct MOTION_COMMAND
	//! @brief [VR}h\
	struct MOTION_COMMAND
	{
		//! @brief tO( Mix::Scene::MOTION_COMMAND_FLAG 񋓒萔̑gݍ킹 )
		UInt32 flags;

		//! @brief nh
		//! @note flags  Mix::Scene::MOTION_CF_ACTIVATE ݒ肳Ăꍇ̂ݗL
		MOTION_HANDLE handle;

		//! @brief t[
		//! @note flags  Mix::Scene::MOTION_CF_FRAME ݒ肳Ăꍇ̂ݗL
		Float32 frame;

		//! @brief [v( Mix::Scene::MOTION_INFINITE_LOOP Ŗ[v )
		//! @note flags  Mix::Scene::MOTION_CF_LOOP ݒ肳Ăꍇ̂ݗL
		UInt32 loopCount;

		//! @brief gWVɗv鎞Ԃ̒( bP )
		//! @note flags  Mix::Scene::MOTION_CF_TRANSITION ݒ肳Ăꍇ̂ݗL
		Float32 transitionTimeLength;
	};

	//! @struct MOTION_ENTRY_DESC
	//! @brief [VGg[\
	struct MOTION_ENTRY_DESC
	{
		Float32 startFrame;	//!< Jnt[
		Float32 endFrame;	//!< It[
		Boolean bAlways;	//!< Jnt[It[̊Ԃ̏ꍇ͏ɌĂяo
		UInt32 userData;	//!< [U[f[^
	};

	//! @enum RENDERER_CAPABILITY_FLAG
	//! @brief _[\̓tO񋓒萔
	enum RENDERER_CAPABILITY_FLAG
	{
		RCAP_WIDGET				=	0x00000001,	//!< EBWFbg( p[eBNAv^[ )
		RCAP_DYNAMICS			=	0x00000002,	//!< _Ci~NX[h
		RCAP_ATMOSPHERE			=	0x00000004,	//!< C
		RCAP_SHADOW_MAPPING		=	0x00000008,	//!< VhE}bsO
		RCAP_AMBIENT_OCCLUSION	=	0x00000010,	//!< ArGgIN[W
		RCAP_LUMINOSITY			=	0x00000020,	//!< PxɂK␳
		RCAP_BLOOM				=	0x00000040,	//!< u[
		RCAP_LIGHT_SHAFTS		=	0x00000080,	//!< CgVtg
		RCAP_LENS_FLARE			=	0x00000100,	//!< YtA
		RCAP_CHROMATISM			=	0x00000200,	//!< F
		RCAP_DEPTH_OF_FIELD		=	0x00000400,	//!< ʊE[x

		//! @brief S
		RCAP_ALL			=	RCAP_WIDGET |
								RCAP_DYNAMICS |
								RCAP_ATMOSPHERE |
								RCAP_SHADOW_MAPPING |
								RCAP_AMBIENT_OCCLUSION |
								RCAP_LUMINOSITY |
								RCAP_BLOOM |
								RCAP_LIGHT_SHAFTS |
								RCAP_LENS_FLARE |
								RCAP_CHROMATISM |
								RCAP_DEPTH_OF_FIELD,
	};

	//! @enum RENDERER_SAMPLING_RESOLUTION
	//! @brief _[ : TvO𑜓x񋓒萔
	enum RENDERER_SAMPLING_RESOLUTION
	{
		RSMPL_DEFAULT	= 0,	//!< ftHg
		RSMPL_DOWN2X	= 1,	//!< XN[TCY1/2
		RSMPL_DOWN4X	= 2,	//!< XN[TCY1/4
	};

	//! @struct RENDERER_CONFIG
	//! @brief _[ݒ\
	struct RENDERER_CONFIG
	{
		//! @brief \͂\ Mix::Scene::RENDERER_CAPABILITY_FLAG 񋓒萔̑gݍ킹
		UInt32 caps;

		//! @brief INg[̗L͈͂̍ŏl
		//! @note p[eBNA[JCgAAN^[fzu͈͂\܂B
		Mix::Vector3 octMin;
		//! @brief INg[̗L͈͂̍ől
		//! @note p[eBNA[JCgAAN^[fzu͈͂\܂B
		Mix::Vector3 octMax;
		//! @brief INg[̕x( 0`7 )
		UInt32 octLevel;

		//! @brief RXgN^
		RENDERER_CONFIG( void )
		{
			caps = Mix::Scene::RCAP_ALL;

			octMin.Set( -500.0f, -500.0f, -500.0f );
			octMax.Set( +500.0f, +500.0f, +500.0f );
			octLevel = 4;
		}
	};

	//! @struct CAMERA_CONFIG
	//! @brief Jݒ\
	struct CAMERA_CONFIG
	{
		//! @brief \͂\ Mix::Scene::RENDERER_CAPABILITY_FLAG 񋓒萔̑gݍ킹
		//! @note
		//! ݒł\͈͂ȉ̂̂Ɍ肳܂B<br>
		//! <br>
		//! RCAP_DYNAMICS<br>
		//! RCAP_AMBIENT_OCCLUSION<br>
		//! RCAP_SHADOW_MAPPING<br>
		//! RCAP_LUMINOSITY<br>
		//! RCAP_BLOOM<br>
		//! RCAP_LIGHT_SHAFTS<br>
		//! RCAP_LENS_FLARE<br>
		//! RCAP_CHROMATISM<br>
		//! RCAP_DEPTH_OF_FIELD<br>
		//! <br>
		//! ܂A_Ci~NX( RCAP_DYNAMICS ) ̓JgpăIuWFNg̃hbO邩ǂw肷̂łāA<br>
		//! _Ci~NX̂ ONAOFF ł͂܂B
		UInt32 caps;

		//! @brief ^[Qbg̃TCY
		//! @note `̃^[Qbg̉𑜓xɂȂ܂B
		Mix::Point targetSize;

		//! @brief [xobt@̃tH[}bg
		Mix::Graphics::FORMAT depthBuffFormat;

		//! @brief J[eNX`tH[}bg
		//! @note gpłtH[}bǵuFMT_R8G8B8A8vuFMT_R16G16B16A16FvuFMT_R32G32B32A32Fv ̂RɂȂ܂B
		Mix::Graphics::FORMAT colorTexFormat;

		//! @brief [xeNX`tH[}bg
		//! @note
		//! p[eBNAʊE[xAArGgIN[W ȂǂŎgp܂B<br>
		//! gpłtH[}bǵuFMT_R16FvuFMT_R32Fv̂QɂȂ܂B<br>
		//! <br>
		//! fobÓAfobO`s悤ɂ邽߂Ɉȉ̂悤ɃtH[}bg߂܂B<br>
		//! <br>
		//! uFMT_R16FvuFMT_R16G16B16A16Fv<br>
		//! uFMT_R32FvuFMT_R32G32B32A32Fv<br>
		Mix::Graphics::FORMAT depthTexFormat;

		//! @brief ܃eNX`tH[}bg
		//! @note
		//! gpłtH[}bǵuFMT_R16G16B16A16FvuFMT_R32G32B32A32Fv̂QɂȂ܂B<br>
		//! FA[xi[邽߁AJ[tH[}bgƐ[x̐xlɂĐݒ肵ĂB
		Mix::Graphics::FORMAT refractTexFormat;

		//! @brief ArGgIN[W̃TvO𑜓x
		//! @note Mix::Scene::RSMPL_DEFAULT w肵ꍇ́AXN[̃TCYɂȂ܂B
		Mix::Scene::RENDERER_SAMPLING_RESOLUTION aoSmplRes;

		//! @brief VhE}bsO̐[xeNX`̃tH[}bg
		//! @note gpłtH[}bǵuFMT_R16G16B16A16FvuFMT_R32G32B32A32Fv̂QɂȂ܂B<br>
		Mix::Graphics::FORMAT smDepthTexFormat;
		//! @brief VhE}bsO̐[xeNX`̈ӂ̃TCY
		//! @note 256lw肵ꍇ́A256w肵Ƃ݂Ȃ܂B
		UInt32 smDepthTexSize;
		//! @brief VhE}bsÕTvO𑜓x
		//! @note Mix::Scene::RSMPL_DEFAULT w肵ꍇ́AXN[̃TCYɂȂ܂B
		Mix::Scene::RENDERER_SAMPLING_RESOLUTION smSmplRes;

		//! @brief PxeNX`tH[}bg
		//! @note
		//! gpłtH[}bǵuFMT_R16FvuFMT_R32Fv̂QɂȂ܂B<br>
		//! <br>
		//! fobÓAfobO`s悤ɂ邽߂Ɉȉ̂悤ɃtH[}bg߂܂B<br>
		//! <br>
		//! uFMT_R16FvuFMT_R16G16B16A16Fv<br>
		//! uFMT_R32FvuFMT_R32G32B32A32Fv<br>
		Mix::Graphics::FORMAT lumTexFormat;

		//! @brief u[̃I[o[t[
		//! @note 0w肵ꍇ́A1w肵Ƃ݂Ȃ܂B
		UInt32 bloomOverflowNum;
		//! @brief u[̃TvO𑜓x
		//! @note Mix::Scene::RSMPL_DEFAULT w肵ꍇ Mix::Scene::RSMPL_DOWN2X w肵ƌȂ܂B
		Mix::Scene::RENDERER_SAMPLING_RESOLUTION bloomSmplRes;

		//! @brief YtÃTvO𑜓x
		//! @note Mix::Scene::RSMPL_DEFAULT w肵ꍇ́AXN[̃TCYɂȂ܂B
		Mix::Scene::RENDERER_SAMPLING_RESOLUTION lfSmplRes;

		//! @brief F̃TvO𑜓x
		//! @note Mix::Scene::RSMPL_DEFAULT w肵ꍇ́AXN[̃TCYɂȂ܂B
		Mix::Scene::RENDERER_SAMPLING_RESOLUTION caSmplRes;

		//! @brief ʊE[x̃TvO𑜓x
		//! @note Mix::Scene::RSMPL_DEFAULT w肵ꍇ́AXN[̃TCYɂȂ܂B
		Mix::Scene::RENDERER_SAMPLING_RESOLUTION dofSmplRes;

		//! @brief RXgN^
		CAMERA_CONFIG( void )
		{
			caps = Mix::Scene::RCAP_ALL;

			depthBuffFormat = Mix::Graphics::FMT_D16;

			colorTexFormat = Mix::Graphics::FMT_R16G16B16A16F;
			depthTexFormat = Mix::Graphics::FMT_R16F;
			refractTexFormat = Mix::Graphics::FMT_R16G16B16A16F;

			aoSmplRes = Mix::Scene::RSMPL_DOWN2X;

			smDepthTexFormat = Mix::Graphics::FMT_R16G16B16A16F;
			smDepthTexSize = 1024;
			smSmplRes = Mix::Scene::RSMPL_DOWN2X;

			lumTexFormat = Mix::Graphics::FMT_R16F;

			bloomOverflowNum = 1;
			bloomSmplRes = Mix::Scene::RSMPL_DOWN2X;

			lfSmplRes = Mix::Scene::RSMPL_DOWN2X;

			caSmplRes = Mix::Scene::RSMPL_DOWN2X;

			dofSmplRes = Mix::Scene::RSMPL_DOWN2X;
		}
	};

	//! @struct BRIGHT_PASS
	//! @brief uCgpX\
	struct BRIGHT_PASS
	{
		Boolean bLumInf;	//!< Px̉e󂯂ꍇ True
		Float32 white;		//!< \Px̋( 0.0f`̖ )
		Float32 threshold;	//!< Px𒊏oۂ臒l( 0.0f`̖ )
		Float32 offset;		//!< Px𒊏oۂ̃ItZbg( 0.0f`̖ )
	};

	//! @struct BLUR
	//! @brief u[\
	struct _MIX_DLL_API BLUR
	{
	public:
		//! @enum TYPE
		//! @brief ^Cv񋓒萔
		enum TYPE
		{
			T_NONE			= 0,	//!< 
			T_KS_3x3		= 1,	//!< 3x3
			T_KS_5x5		= 2,	//!< 5x5
			T_GAUSSIAN		= 3,	//!< KEVAu[
			T_GAUSSIAN_EX	= 4,	//!< KEVAu[EX

			TYPE_MAX		= 5,	//!< ^Cv
		};

		//! @brief RXgN^
		BLUR( void );

		//! @brief ^Cv擾܂
		//! @return ^Cv\ Mix::Scene::BLUR::TYPE 񋓒萔Ԃ܂
		BLUR::TYPE GetType( void ) const;
		//! @brief ^̒l擾܂
		//! @return lԂ܂
		Int32 GetIntValue( void ) const;
		//! @brief _^̒l擾܂
		//! @return lԂ܂
		Float32 GetFloatValue( void ) const;

		//! @brief LǂmF܂
		//! @return L( type != Mix::Scene::BLUR::T_NONE )ȏꍇ True Ԃ܂
		Boolean IsValid( void ) const;

		//! @brief u[Ȃ
		//! @return u[\ Mix::Scene::BLUR \̂Ԃ܂
		static const Mix::Scene::BLUR& NONE( void );

		//! @brief J[lTCY 3x3 ̃u[
		//! @return u[\ Mix::Scene::BLUR \̂Ԃ܂
		//! @note JԂ 1 ɂȂ܂B
		static Mix::Scene::BLUR KS_3x3( void );
		//! @brief J[lTCY 3x3 ̃u[
		//! @param[in] iteration JԂ( 1`16 )
		//! @return u[\ Mix::Scene::BLUR \̂Ԃ܂
		//! @note JԂ GetIntValue() Ŏ擾ł܂B
		static Mix::Scene::BLUR KS_3x3( Int32 iteration );

		//! @brief J[lTCY 5x5 ̃u[
		//! @return u[\ Mix::Scene::BLUR \̂Ԃ܂
		//! @note JԂ 1 ɂȂ܂B
		static Mix::Scene::BLUR KS_5x5( void );
		//! @brief J[lTCY 5x5 ̃u[
		//! @param[in] iteration JԂ( 1`16 )
		//! @return u[\ Mix::Scene::BLUR \̂Ԃ܂
		//! @note JԂ GetIntValue() Ŏ擾ł܂B
		static Mix::Scene::BLUR KS_5x5( Int32 iteration );

		//! @brief KEVAu[
		//! @return u[\ Mix::Scene::BLUR \̂Ԃ܂
		//! @note Ul 0.0001f ɂȂ܂B
		static Mix::Scene::BLUR GAUSSIAN( void );
		//! @brief KEVAu[
		//! @param[in] dispersion Ul( 0.0001f`128.0000f )
		//! @return u[\ Mix::Scene::BLUR \̂Ԃ܂
		//! @note
		//! Ul GetFloatValue() Ŏ擾ł܂B<br>
		//! ܂4܂łłB
		static Mix::Scene::BLUR GAUSSIAN( Float32 dispersion );

		//! @brief KEVAu[EX
		//! @return u[\ Mix::Scene::BLUR \̂Ԃ܂
		//! @note a 4 ɂȂ܂B
		static Mix::Scene::BLUR GAUSSIAN_EX( void );
		//! @brief KEVAu[EX
		//! @param[in] radius a( 4`64 )
		//! @return u[\ Mix::Scene::BLUR \̂Ԃ܂
		//! @note a GetIntValue() Ŏ擾ł܂B
		static Mix::Scene::BLUR GAUSSIAN_EX( Int32 radius );

	private:
		BLUR::TYPE type;
		Int32 data;
	};

	//! @struct DYNAMICS_CONTACT_POINT
	//! @brief ڐG|Cg\
	struct DYNAMICS_CONTACT_POINT
	{
		Mix::Vector3 localPositionA;		//!< g : ڐG|Cg̃[JW
		Mix::Vector3 localPositionB;		//!<  : ڐG|Cg̃[JW

		Mix::Vector3 worldPositionA;		//!<  : ڐG|Cg̃[hW
		Mix::Vector3 worldPositionB;		//!<  : ڐG|Cg̃[hW

		Mix::Vector3 worldNormalB;			//!<  : ڐG|Cg̃[h@

		Float32 penetrationB;				//!< ڐG|Cg̋( ߂荞łꍇ́A̒lɂȂ܂ )

		Mix::Dynamics::MATERIAL materialA;	//!< g : ڐG|Cg̃}eA
		Mix::Dynamics::MATERIAL materialB;	//!<  : ڐG|Cg̃}eA

		Float32 impulse;					//!< ڐG|CgɓKpꂽ
	};

	//! @enum WATER_CONTAINS_RESULT
	//! @brief ʂƂ̔茋ʗ񋓒萔
	enum WATER_CONTAINS_RESULT
	{
		WCR_UNKNOWN		= 0,	//!< s
		WCR_FRONT		= 1,	//!< ʂO
		WCR_BACK		= 2,	//!< ʂ艜
		WCR_OVERLAP		= 3,	//!< ʂƏdȂĂ
	};

	//! @enum DYNAMICS_COLLIDER_MODE
	//! @brief _Ci~NXRC_[[h񋓒萔
	enum DYNAMICS_COLLIDER_MODE
	{
		//! @brief ftHg
		//! @note RC_[fGfB^Őݒ肳ꂽԂɂ܂B
		DC_DEFAULT		= 0,

		//! @brief X^eBbN
		//! @note
		//! SẴRC_[IɃX^eBbNԂɂ܂B
		DC_STATIC		= 1,

		//! @brief Ll}eBbN
		//! @note SẴRC_[IɃLl}eBbNԂɂ܂
		DC_KINEMATIC	= 2,

		//! @brief Oh[
		//! @note X^eBbNwȊÕRC_[ftHgԂɂ܂
		DC_RAGDOLL		= 3,
	};

	//! @enum DYNAMICS_KCHAR_MODE
	//! @brief _Ci~NXLl}eBbNLN^[[h
	enum DYNAMICS_KCHAR_MODE
	{
		//! @brief M
		//! @note f̃[hgXtH[Ll}eBbNLN^[ɔf܂
		DKC_RECEIVE	= 0,

		//! @brief e
		//! @note Ll}eBbNLN^[̃[hgXtH[fɔf܂
		DKC_CAST	= 1,
	};

	//! @enum DEBUG_DRAW_METHOD
	//! @brief fobO : `惁\bh񋓒萔
	enum DEBUG_DRAW_METHOD
	{
		//! @brief p[eBNAf`悷OɃfobO`s܂
		//! @note |Šɂ̂`悳܂A|XgGtFNg̉e󂯂܂
		DDM_BEFORE	= 0,

		//! @brief p[eBNAf`悵ɃfobO`s܂
		//! @note |XgGtFNg̉e󂯂܂񂪁A|Šɂ͕̂`悳ȂȂ܂
		DDM_AFTER	= 1,

		//! @brief Aʏs킸AőOʂɃfobO`s܂
		DDM_XRAYS	= 2,
	};

	//! @enum DEBUG_DRAW_FLAG
	//! @brief fobO : `tO񋓒萔
	enum DEBUG_DRAW_FLAG
	{
		DDF_OCTREE				= 0x00000001,	//!<  : E

		DDF_DIRLIGHT_SHAPE		= 0x00000002,	//!< fBNViCg : `

		DDF_SPOTLIGHT_SHAPE		= 0x00000004,	//!< X|bgCg : `
		DDF_SPOTLIGHT_BOUNDS	= 0x00000008,	//!< X|bgCg : E

		DDF_POINTLIGHT_SHAPE	= 0x00000010,	//!< |CgCg : `
		DDF_POINTLIGHT_BOUNDS	= 0x00000020,	//!< |CgCg : E

		DDF_SHADOW_BOUNDS		= 0x00000040,	//!< VhE : E

		DDF_WIDGET_GROUP_BOUNDS	= 0x00000080,	//!< EBWFbg : O[v̋E

		DDF_PARTICLE_MESH		= 0x00000100,	//!< p[eBN : bV
		DDF_PARTICLE_AXIS		= 0x00000200,	//!< p[eBN : 
		DDF_PARTICLE_BOUNDS		= 0x00000400,	//!< p[eBN : E
		DDF_PARTICLE_GENERATOR	= 0x00000800,	//!< p[eBN : WFl[^[
		DDF_PARTICLE_PROCESSOR	= 0x00001000,	//!< p[eBN : vZbT[

		DDF_PLANTER_MESH		= 0x00002000,	//!< v^[ : bV
		DDF_PLANTER_BOUNDS		= 0x00004000,	//!< v^[ : E

		DDF_ACTORMODEL_MESH		= 0x00008000,	//!< AN^[f : bV
		DDF_ACTORMODEL_AXIS		= 0x00010000,	//!< AN^[f : 
		DDF_ACTORMODEL_BOUNDS	= 0x00020000,	//!< AN^[f : E
		DDF_ACTORMODEL_SKELETAL	= 0x00040000,	//!< AN^[f : i
		DDF_ACTORMODEL_KCHAR	= 0x00080000,	//!< AN^[f : Ll}eBbNLN^
		DDF_ACTORMODEL_COLLIDER	= 0x00100000,	//!< AN^[f : RC_[
		DDF_ACTORMODEL_SENSOR	= 0x00200000,	//!< AN^[f : ZT[
		DDF_ACTORMODEL_JOINT	= 0x00400000,	//!< AN^[f : WCg

		DDF_TERRAINMODEL_MESH	= 0x00800000,	//!< eCf : bV
		DDF_TERRAINMODEL_BOUNDS	= 0x01000000,	//!< eCf : E

		DDF_WATERPOOL_BOUNDS	= 0x02000000,	//!< EH[^[v[ : E

		DDF_PP_FILMIC			= 0x04000000,	//!< |XgvZX : tB~bN
		DDF_PP_CHROMATISM		= 0x08000000,	//!< |XgvZX : F
		DDF_PP_LENS_DISTORTION	= 0x10000000,	//!< |XgvZX : cȎ

		DDF_FLOOR_COLLIDER		= 0x20000000,	//!< tA : RC_[
		DDF_GHOST_COLLIDER		= 0x40000000,	//!< S[Xg : RC_[

		//! @brief bV
		DDF_MESH				= ( DDF_PLANTER_MESH | DDF_PARTICLE_MESH | DDF_ACTORMODEL_MESH | DDF_TERRAINMODEL_MESH ),
		//! @brief 
		DDF_AXIS				= ( DDF_PARTICLE_AXIS | DDF_ACTORMODEL_AXIS ),
		//! @brief E
		DDF_BOUNDS				= ( DDF_SPOTLIGHT_BOUNDS | DDF_POINTLIGHT_BOUNDS | DDF_PARTICLE_BOUNDS | DDF_ACTORMODEL_BOUNDS | DDF_TERRAINMODEL_BOUNDS | DDF_WATERPOOL_BOUNDS | DDF_PLANTER_BOUNDS ),

		//! @brief SẴCǧ`
		DDF_LIGHT_SHAPE			= ( DDF_DIRLIGHT_SHAPE | DDF_SPOTLIGHT_SHAPE | DDF_POINTLIGHT_SHAPE ),
		//! @brief SẴCg̋E
		DDF_LIGHT_BOUNDS		= ( DDF_SPOTLIGHT_BOUNDS | DDF_POINTLIGHT_BOUNDS ),
		//! @brief SẴCg
		DDF_LIGHT				= ( DDF_LIGHT_SHAPE | DDF_LIGHT_BOUNDS ),
		//! @brief fBNViCg
		DDF_DIRLIGHT			= ( DDF_DIRLIGHT_SHAPE ),
		//! @brief X|bgCg
		DDF_SPOTLIGHT			= ( DDF_SPOTLIGHT_SHAPE | DDF_SPOTLIGHT_BOUNDS ),
		//! @brief |CgCg
		DDF_POINTLIGHT			= ( DDF_POINTLIGHT_SHAPE | DDF_POINTLIGHT_BOUNDS ),

		//! @brief VhE
		DDF_SHADOW				= ( DDF_SHADOW_BOUNDS ),

		//! @brief EBWFbg
		DDF_WIDGET				= ( DDF_WIDGET_GROUP_BOUNDS ),
		//! @brief v^[
		DDF_PLANTER				= ( DDF_PLANTER_MESH | DDF_PLANTER_BOUNDS ),
		//! @brief p[eBN
		DDF_PARTICLE			= ( DDF_PARTICLE_MESH | DDF_PARTICLE_AXIS | DDF_PARTICLE_BOUNDS | DDF_PARTICLE_GENERATOR | DDF_PARTICLE_PROCESSOR ),

		//! @brief AN^[f
		DDF_ACTORMODEL			= ( DDF_ACTORMODEL_MESH | DDF_ACTORMODEL_AXIS | DDF_ACTORMODEL_BOUNDS | DDF_ACTORMODEL_SKELETAL | DDF_ACTORMODEL_KCHAR | DDF_ACTORMODEL_COLLIDER | DDF_ACTORMODEL_SENSOR | DDF_ACTORMODEL_JOINT ),
		//! @brief eCf
		DDF_TERRAINMODEL		= ( DDF_TERRAINMODEL_MESH | DDF_TERRAINMODEL_BOUNDS ),

		//! @brief EH[^[v[
		DDF_WATERPOOL			= ( DDF_WATERPOOL_BOUNDS ),

		//! @brief tA
		DDF_FLOOR				= ( DDF_FLOOR_COLLIDER ),

		//! @brief S[Xg
		DDF_GHOST				= ( DDF_GHOST_COLLIDER ),

		//! @brief _Ci~NX
		DDF_DYNAMICS			= ( DDF_FLOOR |
									DDF_GHOST |
									DDF_ACTORMODEL_SKELETAL |
									DDF_ACTORMODEL_KCHAR |
									DDF_ACTORMODEL_COLLIDER |
									DDF_ACTORMODEL_SENSOR |
									DDF_ACTORMODEL_JOINT ),
	};

	//! @enum DEBUG_DRAW_COLOR_TYPE
	//! @brief fobO : `J[^Cv񋓒萔
	enum DEBUG_DRAW_COLOR_TYPE
	{
		DDC_COLLIDER_AROUSAL		= 0,	//!< RC_[ : Ɋ
		DDC_COLLIDER_ACTIVE			= 1,	//!< RC_[ : 
		DDC_COLLIDER_SLEEPY			= 2,	//!< RC_[ : x~ɂȂȌ
		DDC_COLLIDER_REST			= 3,	//!< RC_[ : x~
		DDC_COLLIDER_DISABLE		= 4,	//!< RC_[ : ( V~[V͍sĂȂ )

		DDC_SENSOR					= 5,	//!< ZT[

		DDC_KINEMATIC_CHARACTER		= 6,	//!< Ll}eBbNLN^[

		DDC_JOINT_FRAME				= 7,	//!< WCg : t[
		DDC_JOINT_LIMIT				= 8,	//!< WCg : ~bg

		DDC_BOUNDS					= 9,	//!< E

		DDC_OCTREE_NODE_BOUNDS		= 10,	//!< INg[ : m[h̋E
		DDC_OCTREE_OBJS_BOUNDS		= 11,	//!< INg[ : IuWFNg̋E

		DDC_LIGHT_SHAPE				= 12,	//!< Cg : `
		DDC_PARTICLE_QUAD			= 13,	//!< p[eB : `
		DDC_ACTORMODEL_SKELETAL		= 14,	//!< AN^[f : i
		DDC_SM_CLIP_BOOUNDS			= 15,	//!< VhE}bsO : NbvE
		DDC_SM_CAST_BOOUNDS			= 16,	//!< VhE}bsO : LXgE

		DDC_FILMIC_BG				= 17,	//!< tB~bN : wi
		DDC_FILMIC_MEMORY			= 18,	//!< tB~bN : 
		DDC_FILMIC_CURVE			= 19,	//!< tB~bN : J[u

		DDC_ABERRATION				= 20,	//!< FAcȎ̊iq̐F
	};

	//! @enum DEBUG_PROFILE_TYPE
	//! @brief fobO : vt@C^Cv񋓒萔
	enum DEBUG_PROFILE_TYPE
	{
		DPT_GENERAL				= 0,	//!< S
		DPT_DYNAMICS			= 1,	//!< _Ci~NX
		DPT_OCTREE				= 2,	//!< 
		DPT_LIGHT				= 3,	//!< Cg
		DPT_WATER_POOL			= 4,	//!< EH[^[v[
		DPT_WIDGET				= 5,	//!< EBWFbg
		DPT_ACTOR_MODEL			= 6,	//!< AN^[f
		DPT_TERRAIN_MODEL		= 7,	//!< eCf
		DPT_PROJ_SHADOW			= 8,	//!< VhE̓e
		DPT_DRAW_OPACITY		= 9,	//!< s̕`
		DPT_DRAW_NEUTRALITY		= 10,	//!< s̕`Ƌ܂̕`̊Ԃɍs`
		DPT_DRAW_REFRACT		= 11,	//!< ܂̕`
		DPT_DRAW_TRANSPARENCY	= 12,	//!< ̕`
		DPT_POST_PROCESS		= 13,	//!< |XgvZX
	};

	//! @struct DEBUG_PROFILE_RENDERER_GENERAL
	//! @brief fobO : _[ : WFlvt@C\
	struct DEBUG_PROFILE_RENDERER_GENERAL
	{
		Float32 updElapsedTime;		//!< XV( Mix::Scene::IRenderer::Update )ɂ( bP )
		Float32 refElapsedTime;		//!< tbV( Mix::Scene::IRenderer::Refresh )ɂ( bP )
		Float32 drawElapsedTime;	//!< SẴJɂ`( Mix::Scene::ICamera::Draw )ɂ( bP )
		Float32 finElapsedTime;		//!< ㏈ɂ( bP )

		UInt32 drawPrimCount;		//!< SẴJɂ`悳ꂽv~eBu
	};

	//! @struct DEBUG_PROFILE_RENDERER_DYNAMICS
	//! @brief fobO : _[ : _Ci~NXvt@C\
	//! @note ̍\̂̃p[^̒ĺAMix::Scene::IRenderer::Update ɂčXV܂B
	struct DEBUG_PROFILE_RENDERER_DYNAMICS
	{
		Float32 ssElapsedTime;	//!< V~[Vɂ( bP )
		Float32 cpElapsedTime;	//!< ڐG̎Wɂ( bP )
	};

	//! @struct DEBUG_PROFILE_RENDERER_OCTREE
	//! @brief fobO : _[ : ؃vt@C\
	//! @note ̍\̂̃p[^̒ĺAMix::Scene::IRenderer::Refresh ɂčXV܂B
	struct DEBUG_PROFILE_RENDERER_OCTREE
	{
		UInt32 nodeCount;						//!< ݂̃m[h
		UInt32 nodeMax;							//!< m[h̍ő吔
		Mix::Vector3 unitSize;					//!< [tƂȂqԂ̃TCY

		UInt32 illegalLocalLightNum;			//!< C[Kȃ[JCg̐
		UInt32 illegalLeavingParticleNum;		//!< C[Kȃ[rOp[eBN̐
		UInt32 illegalScatterParticleUnitNum;	//!< C[KȃXLb^[p[eBÑjbg̐
		UInt32 illegalActorModelNum;			//!< C[KȃAN^[f̐
	};

	//! @struct DEBUG_PROFILE_CAMERA_GENERAL
	//! @brief fobO : J : WFlvt@C\
	struct DEBUG_PROFILE_CAMERA_GENERAL
	{
		Float32 drawElapsedTime;	//!< `( Mix::Scene::ICamera::Draw )ɂ( bP )
		UInt32 drawPrimCount;		//!< `悳ꂽv~eBu
	};

	//! @struct DEBUG_PROFILE_CAMERA_OCTREE
	//! @brief fobO : J : ؃vt@C\
	struct DEBUG_PROFILE_CAMERA_OCTREE
	{
		Float32 ccElapsedTime;	//!< `悷IuWFNg̎Wɂ( bP )
		Float32 csElapsedTime;	//!< eƂēeIuWFNg̎Wɂ( bP )
		Float32 fElapsedTime;	//!< IuWFNgW̏ɂ( bP )
	};

	//! @struct DEBUG_PROFILE_CAMERA_LIGHT
	//! @brief fobO : J : Cgvt@C\
	struct DEBUG_PROFILE_CAMERA_LIGHT
	{
		UInt32 vSpotCount;		//!< EɓĂX|bgCg̐
		UInt32 tSpotCount;		//!< SẴX|bgCg̐

		UInt32 vPointCount;		//!< Eɓė|CgCg̐
		UInt32 tPointCount;		//!< SẴ|CgCg̐

		Float32 vcElapsedTime;	//!< EɓĂ郍[JCg̎Wɂ( bP )
		Float32 vsElapsedTime;	//!< EɓĂ郍[JCg̃\[gɂ( bP )
	};

	//! @struct DEBUG_PROFILE_CAMERA_WATER_POOL
	//! @brief fobO : J : EH[^[v[vt@C
	struct DEBUG_PROFILE_CAMERA_WATER_POOL
	{
		Float32 vElapsedTime;	//!< EɓĂEH[^[v[̐
		UInt32 vCount;			//!< EɓĂSăEH[^[v[̐
		UInt32 vrCount;			//!< EɓĂܔɎgpĂEH[^[v[̐
		UInt32 tCount;			//!< SẴEH[^[v[̐
	};

	//! @struct DEBUG_PROFILE_CAMERA_WIDGET
	//! @brief fobO : J : EBWFbgvt@C\
	struct DEBUG_PROFILE_CAMERA_WIDGET
	{
		//! @struct DEBUG_PROFILE_LEAVING_PARTICLE
		//! @brief fobO : [rOp[eBNvt@C\
		struct DEBUG_PROFILE_LEAVING_PARTICLE
		{
			UInt32 vCount;			//!< EɓĂ郊[rOp[eBN̐
			UInt32 tCount;			//!< SẴ[rOp[eBN̐
			Float32 vElapsedTime;	//!< EɓĂ郊[rO̎Wɂ( bP )
		}lp; //!< [rOp[eBNvt@C

		//! @struct DEBUG_PROFILE_SCATTER_PARTICLE
		//! @brief fobO : XLb^[p[eBNvt@C\
		struct DEBUG_PROFILE_SCATTER_PARTICLE
		{
			UInt32 vCount;		//!< EɓĂXLb^[p[eBÑjbg̐
			UInt32 tCount;		//!< SẴXLb^[p[eBÑjbg̐
			Float32 vElapsedTime;	//!< EɓĂXLb^[p[eBN̎Wɂ( bP )
		}sp; //!< XLb^[p[eBNvt@C

		//! @struct DEBUG_PROFILE_PLANTER
		//! @brief fobO : v^[vt@C\
		struct DEBUG_PROFILE_PLANTER
		{
			UInt32 vCount;			//!< EɓĂv^[̐
			UInt32 tCount;			//!< SẴv^[̐
			Float32 vElapsedTime;	//!< EɓĂv^[̎Wɂ( bP )
		}pl; //!< v^[vt@C

		UInt32 subsetCount;		//!< TuZbg̐
		UInt32 quadCount;		//!< Nbh̐
		UInt32 objCount;		//!< TuZbgANbh琶ꂽIuWFNg̐
		UInt32 comCount;		//!< IuWFNgɐꂽR}h̐

		Float32 slElapsedTime;	//!< [JCeBOsEBWFbg̃\[gɂ( bP )
		Float32 alElapsedTime;	//!< [JCeBOɂ( bP )
		Float32 goElapsedTime;	//!< TuZbg甼IuWFNg̐ɂ( bP )
	};

	//! @struct DEBUG_PROFILE_CAMERA_MODEL
	//! @brief fobO : J : fvt@C\
	struct DEBUG_PROFILE_CAMERA_MODEL
	{
		UInt32 vCount;			//!< EɓĂ郂f̐
		UInt32 sCount;			//!< VhE}bsOsf̐
		UInt32 tCount;			//!< SẴf̐
		Float32 vcElapsedTime;	//!< EɓĂ郂f̎WAR}h̐ɂ( bP )
		Float32 cmElapsedTime;	//!< VhE}bsOsf̎Wɂ( bP )
	};

	//! @struct DEBUG_PROFILE_CAMERA_PROJ_SHADOW
	//! @brief fobO : J : VhEevt@C\
	struct DEBUG_PROFILE_CAMERA_PROJ_SHADOW
	{
		UInt32 comCount;			//!< R}h̐
		UInt32 comCapacity;			//!< R}h̃LpVeB

		Float32 preElapsedTime;		//!< O( \[g )ɂ( bP )
		Float32 drawElapsedTime;	//!< `ɂ( bP )
	};

	//! @struct DEBUG_PROFILE_CAMERA_DRAW_OPACITY
	//! @brief fobO : J : s`vt@C\
	struct DEBUG_PROFILE_CAMERA_DRAW_OPACITY
	{
		UInt32 comCount;			//!< R}h̐
		UInt32 comCapacity;			//!< R}h̃LpVeB

		Float32 preElapsedTime;		//!< O( \[g )ɂ( bP )
		Float32 drawElapsedTime;	//!< `ɂ( bP )
	};

	//! @struct DEBUG_PROFILE_CAMERA_DRAW_NEUTRALITY
	//! @brief fobO : J : s`Ɣ`( ܕ`܂ )̊Ԃ̕`vt@C\
	struct DEBUG_PROFILE_CAMERA_DRAW_NEUTRALITY
	{
		Float32 aoElapsedTime;	//!< ArGgIN[Wɂ( bP )
		Float32 asElapsedTime;	//!< C̕`ɂ( bP )
	};

	//! @struct DEBUG_PROFILE_CAMERA_DRAW_REFRACT
	//! @brief fobO : J : ܕ`vt@C\
	struct DEBUG_PROFILE_CAMERA_DRAW_REFRACT
	{
		UInt32 comCount;			//!< R}h̐
		UInt32 comCapacity;			//!< R}h̃LpVeB

		Float32 maskElapsedTime;	//!< ܃}XN̕`ɂ( bP )
		Float32 drawElapsedTime;	//!< ܂̕`ɂ( bP )
	};

	//! @struct DEBUG_PROFILE_CAMERA_DRAW_TRANSPARENCY
	//! @brief fobO : J : vt@C\
	struct DEBUG_PROFILE_CAMERA_DRAW_TRANSPARENCY
	{
		UInt32 objCount;			//!< IuWFNg
		UInt32 objCapacity;			//!< IuWFNg̃LpVeB

		UInt32 comCount;			//!< R}h̐
		UInt32 comCapacity;			//!< R}h̃LpVeB

		UInt32 bkComCount;			//!< ܖʂ̕`ɎgpꂽR}h̐( ܖʂƏdȂĂ̂܂ )
		UInt32 bkComCapacity;		//!< ܖʂ̕`ɎgpꂽR}h̃LpVeB

		UInt32 frComCount;			//!< ܖʂO̕`ɎgpꂽR}h̐( ܖʂƏdȂĂ̂܂ )
		UInt32 frComCapacity;		//!< ܖʂO̕`ɎgpꂽR}h̃LpVeB

		UInt32 ovComCount;			//!< ܖʂƏdȂĂ(I[obv)R}h̐

		Float32 soElapsedTime;		//!< IuWFNg̃\[gɂ( bP )
		Float32 gcElapsedTime;		//!< IuWFNgR}h̐ɂ( bP )
		Float32 dcElapsedTime;		//!< ܖʂɑ΂ÕR}h̕ɂ( bP )
		Float32 bkElapsedTime;		//!< ܖʂ̕`ɂ( bP )
		Float32 frElapsedTime;		//!< ܖʂO̕`ɂ( bP )
	};

	//! @struct DEBUG_PROFILE_CAMERA_POST_PROCESS
	//! @brief fobO : J : |XgvZXvt@C\
	struct DEBUG_PROFILE_CAMERA_POST_PROCESS
	{
		Float32 smElapsedTime;		//!< VhE}bsOɂ( bP )
		Float32 uwElapsedTime;		//!< ʉɂ( bP )
		Float32 lumTrElapsedTime;	//!< Px̕ϊAɂ( bP )
		Float32 lbElapsedTime;		//!< u[ɂ( bP )
		Float32 lsElapsedTime;		//!< CgVtgɂ( bP )
		Float32 lfElapsedTime;		//!< YtAɂ( bP )
		Float32 lumOpElapsedTime;	//!< Px̓Kpɂ( bP )
		Float32 fmElapsedTime;		//!< tB~bNɂ( bP )
		Float32 gcElapsedTime;		//!< K}␳ɂ( bP )
		Float32 caElapsedTime;		//!< Fɂ( bP )
		Float32 dofElapsedTime;		//!< ʊE[xɂ( bP )
		Float32 ldElapsedTime;		//!< cȎɂ( bP )
		Float32 viElapsedTime;		//!< Blbgɂ( bP )
		Float32 aaElapsedTime;		//!< A`GCAVOɂ( bP )
		Float32 finalElapsedTime;	//!< ŏI( obNobt@ւ̃Rs[ )ɂ( bP )
	};

	//! @enum DEBUG_IMAGE_TYPE
	//! @brief fobO : C[W񋓒萔
	enum DEBUG_IMAGE_TYPE
	{
		//! @brief [x
		DIT_DEPTH				= 0,

		//! @brief f[^
		//! @note
		//! RGB=r[@<br>
		//! A=XJCh[}XN
		DIT_DATA				= 1,

		//! @brief ArGgIN[W
		//! @note
		//! 0:J[<br>
		//! 1:J[̂ڂ
		DIT_AMBIENT_OCCLUSION	= 2,

		//! @brief VhE}bsO
		//! @note
		//! 0:[x<br>
		//! 1:J[<br>
		//! 2:J[̂ڂ<br>
		DIT_SHADOW_MAPPING		= 3,

		//! @brief ~mVeB
		//! @note
		//! 0:݂̋Px<br>
		//! 1:Px
		DIT_LUMINOSITY			= 4,

		//! @brief u[
		//! @note
		//! 0:uCgpX<br>
		//! 1ȍ~:I[o[t[
		DIT_BLOOM				= 5,

		//! @brief CgVtg
		//! @note
		//! 0:uCgpX
		//! 1:J[
		DIT_LIGHT_SHAFTS		= 6,

		//! @brief YtA
		//! @note
		//! 0:uCgpX
		//! 1:J[
		DIT_LENS_FLARE			= 7,

		//! @brief F
		//! @note
		//! 0:J[̍
		DIT_CHROMATISM			= 8,

		//! @brief ʊE[x
		//! @note
		//! 0:J[̂ڂ1<br>
		//! 1:J[̂ڂ2
		DIT_DOF					= 9,
	};

	//! @brief }l[W̃|C^擾܂
	//! @return }l[W\ Mix::Scene::IManager C^[tF[X̃|C^Ԃ܂
	_MIX_DLL_API Mix::Scene::IManager* GetManagerPtr( void );
	//! @brief }l[W擾܂
	//! @param[out] ppManager }l[W\ Mix::Scene::IManager C^[tF[X̃|C^̃AhX
	//! @return ꍇ True Ԃ܂
	//! @note 擾}l[W͎QƃJE^ +1 ܂B
	_MIX_DLL_API Boolean GetManager( Mix::Scene::IManager** ppManager );

}}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// }N
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifdef _DEBUG

	//! @def MIX_ABORT
	//! @brief f}N
	#define MIX_ABORT ( *( ( int* )0x0 ) = 0x0 )

	//! @def MIX_ASSERT
	//! @brief AT[g}N
	#define MIX_ASSERT( cnd )\
	{\
		if( !( cnd ) )\
		{\
			char text[1024];\
			::sprintf_s( text, sizeof( text ), "File : \"%s\"\nLine : %d\nCondition : %s", __FILE__, __LINE__, #cnd );\
			::MessageBoxA( ::GetActiveWindow(), text, "Assert", MB_OK | MB_ICONSTOP );\
			MIX_ABORT;\
		}\
	}\

	//! @def MIX_ASSERT_EX_W
	//! @brief gAT[g}N( jR[h )
	#define MIX_ASSERT_EX_W( cnd, mes, ... ) { \
			if( !( cnd ) )\
			{\
				wchar_t fmt[1024] = L"File : \"%s\"\nLine : %d\nCondition : %s\n\n"; \
				wchar_t text[1024]; \
				::wcscat_s( fmt, ( sizeof( fmt ) >> 1 ), mes ); \
				::swprintf_s( text, fmt, __FILEW__, __LINE__, L#cnd, __VA_ARGS__ ); \
				::MessageBoxW( ::GetActiveWindow(), text, L"Error", MB_OK | MB_ICONSTOP ); \
				MIX_ABORT; \
			}\
		}

	//! @def MIX_ASSERT_EX_A
	//! @brief gAT[g}N( }`oCg )
	#define MIX_ASSERT_EX_A( cnd, mes, ... ) { \
			if( !( cnd ) )\
			{\
				char fmt[1024] = "File : \"%s\"\nLine : %d\nCondition : %s\n\n"; \
				char text[1024]; \
				::strcat_s( fmt, sizeof( fmt ), mes ); \
				::sprintf_s( text, sizeof( text ), fmt, __FILE__, __LINE__, #cnd, __VA_ARGS__ ); \
				::MessageBoxA( ::GetActiveWindow(), text, "Error", MB_OK | MB_ICONSTOP ); \
				MIX_ABORT; \
			}\
		}

	//! @def MIX_ERROR_W
	//! @brief G[}N( jR[h )
	#define MIX_ERROR_W( mes, ... ) { \
			wchar_t fmt[1024] = L"File : \"%s\"\nLine : %d\n\n"; \
			wchar_t text[1024]; \
			::wcscat_s( fmt, ( sizeof( fmt ) >> 1 ), mes ); \
			::swprintf_s( text, fmt, __FILEW__, __LINE__, __VA_ARGS__ ); \
			::MessageBoxW( ::GetActiveWindow(), text, L"Error", MB_OK | MB_ICONSTOP ); \
		}

	//! @def MIX_ERROR_A
	//! @brief G[{bNX}N( }`oCg )
	#define MIX_ERROR_A( mes, ... ) { \
			char fmt[1024] = "File : \"%s\"\nLine : %d\n\n"; \
			char text[1024]; \
			::strcat_s( fmt, sizeof( fmt ), mes ); \
			::sprintf_s( text, sizeof( text ), fmt, __FILE__, __LINE__, __VA_ARGS__ ); \
			::MessageBoxA( ::GetActiveWindow(), text, "Error", MB_OK | MB_ICONSTOP ); \
		}

	//! @def MIX_TRACE_W
	//! @brief g[X}N( jR[h )
	#define MIX_TRACE_W( fmt, ... ) { \
			wchar_t text[1024] = L""; \
			::swprintf_s( text, fmt, __VA_ARGS__ ); \
			::OutputDebugStringW( text ); \
		}

	//! @def MIX_TRACE_A
	//! @brief g[X}N( }`oCg )
	#define MIX_TRACE_A( fmt, ... ) { \
			char text[1024] = ""; \
			::sprintf_s( text, sizeof( text ), fmt, __VA_ARGS__ ); \
			::OutputDebugStringA( text ); \
		}

	//! @def MIX_TRACELINE_W
	//! @brief g[XC}N( jR[h )
	#define MIX_TRACELINE_W( fmt, ... ) { \
			wchar_t text[1024] = L""; \
			::swprintf_s( text, fmt, ##__VA_ARGS__ ); \
			::wcscat_s( text, sizeof( text ) >> 1, L"\n" ); \
			::OutputDebugStringW( text ); \
		}

	//! @def MIX_TRACELINE_A
	//! @brief g[XC}N( }`oCg )
	#define MIX_TRACELINE_A( fmt, ... ) { \
			char text[1024] = ""; \
			::sprintf_s( text, sizeof( text ), fmt, __VA_ARGS__ ); \
			::strcat_s( text, sizeof( text ), "\n" ); \
			::OutputDebugStringA( text ); \
		}

	//! @struct MIX_DEBUGNAME_STRUCT
	//! @brief fobOl[\
	struct _MIX_DLL_API MIX_DEBUGNAME_STRUCT
	{
	private:
		wchar_t text[512];

	public:
		//! @brief RXgN^
		//! @param[in] fileName t@C
		//! @param[in] line s
		MIX_DEBUGNAME_STRUCT( const wchar_t* fileName, UInt32 line )
		{
			::wsprintfW( text, L"%s[%d]", fileName, line );
		}

		//! @brief RXgN^
		//! @param[in] title ^Cg
		//! @param[in] fileName t@C
		//! @param[in] line s
		MIX_DEBUGNAME_STRUCT( const wchar_t* title, const wchar_t* fileName, UInt32 line )
		{
			::wsprintfW( text, L"%s : %s[%d]", title, fileName, line );
		}

		//! @brief ^ϊ
		//! @return ꂽfobOl[
		operator const wchar_t*( void )
		{
			return text;
		}
	};

	//! @def MIX_DEBUGNAME
	//! @brief fobOl[
	#define MIX_DEBUGNAME MIX_DEBUGNAME_STRUCT( __FILEW__, __LINE__ )
	//! @def MIX_DEBUGNAME_T
	//! @brief fobOl[( ^Cg )
	#define MIX_DEBUGNAME_T( title ) MIX_DEBUGNAME_STRUCT( title, __FILEW__, __LINE__ )

	//! @def MIX_ASSERT_EX
	//! @brief gAT[g}N
	#define MIX_ASSERT_EX MIX_ASSERT_EX_W
	//! @def MIX_ERROR
	//! @brief G[{bNX}N
	#define MIX_ERROR MIX_ERROR_W
	//! @def MIX_TRACE
	//! @brief g[X}N
	#define MIX_TRACE MIX_TRACE_W
	//! @def MIX_TRACELINE
	//! @brief g[XC}N
	#define MIX_TRACELINE MIX_TRACELINE_W

#else //_DEBUG

	#define MIX_ABORT
	#define MIX_ASSERT( cnd )
	#define MIX_ASSERT_EX_W( cnd, mes, ... )
	#define MIX_ASSERT_EX_A( cnd, mes, ... )
	#define MIX_ERROR_W( mes, ... )
	#define MIX_ERROR_A( mes, ... )
	#define MIX_TRACE_W( fmt, ... )
	#define MIX_TRACE_A( fmt, ... )
	#define MIX_TRACELINE_W( fmt, ... )
	#define MIX_TRACELINE_A( fmt, ... )
	#define MIX_ASSERT_EX( cnd, mes, ... )
	#define MIX_ERROR( mes, ... )
	#define MIX_TRACE( fmt, ... )
	#define MIX_TRACELINE( fmt, ... )
	#define MIX_DEBUGNAME L""
	#define MIX_DEBUGNAME_T( title ) L""

#endif //_DEBUG

//! @def MIX_DELETE
//! @brief 폜}N
#define MIX_DELETE( x ) \
	if( x != NULL ) \
	{ \
		delete x; \
		x = NULL; \
	}

//! @def MIX_DELETE_ARRAY
//! @brief z폜}N
#define MIX_DELETE_ARRAY( x ) \
	if( x != NULL ) \
	{ \
		delete [] x; \
		x = NULL; \
	}

//! @def MIX_ADD_REF
//! @brief QƃJE^CNg}N
#define MIX_ADD_REF( x ) \
	if( x != NULL ) \
	{ \
		x->AddRef(); \
	}

//! @def MIX_RELEASE
//! @brief }N
#define MIX_RELEASE( x ) \
	if( x != NULL ) \
	{ \
		x->Release(); \
		x = NULL; \
	}

//! @def MIX_SETBIT
//! @brief rbgZbg܂
#define MIX_SETBIT( flags, bit )\
	if( ( flags & ( bit ) ) == 0 )\
	{\
		flags |= ( bit );\
	}\

//! @def MIX_RESETBIT
//! @brief rbgZbg܂
#define MIX_RESETBIT( flags, bit )\
	if( ( flags & ( bit ) ) == ( bit ) )\
	{\
		flags ^= ( bit );\
	}\

//! @def MIX_TESTBIT
//! @brief rbgeXg܂
#define MIX_TESTBIT( flags, bit ) ( ( flags ) & ( bit ) )

//! @def MIX_PI
//! @brief ~
#define MIX_PI 3.141592654f
//! @def MIX_2PI
//! @brief ~ * 2
#define MIX_2PI 6.283185308f
//! @def MIX_4PI
//! @brief ~ * 4
#define MIX_4PI 12.566370616f
//! @def MIX_HALF_PI
//! @brief ~ / 2
#define MIX_HALF_PI 1.570796327f
//! @def MIX_QUARTER_PI
//! @brief ~ / 4
#define MIX_QUARTER_PI 0.7853981635f
//! @def MIX_TO_RAD
//! @brief w肳ꂽpx(x@)WAPʂɕϊ܂
#define MIX_TO_RAD( x ) ( MIX_PI * ( x ) / 180.0f )
//! @def MIX_TO_DEG
//! @brief w肳ꂽpx(WA)x@ɕϊ܂
#define MIX_TO_DEG( x ) ( ( x ) * 180.0f / MIX_PI )

//! @def MIX_FLOAT_MIN
//! @brief _̍ŏl
#define MIX_FLOAT_MIN 1.175494351e-38F
//! @def MIX_FLOAT_MAX
//! @brief _̍ől
#define MIX_FLOAT_MAX 3.402823466e+38F
//! @def MIX_FLOAT_EPSILON
//! @brief _CvV
#define MIX_FLOAT_EPSILON 1.192092896e-07F
//! @def MIX_FLOAT_IS_ZERO
//! @brief _̒l0ǂԂ܂
#define MIX_FLOAT_IS_ZERO( a ) ( ( -MIX_FLOAT_EPSILON < ( a ) ) && ( MIX_FLOAT_EPSILON > ( a ) ) )
//! @def MIX_FLOAT_EQUAL
//! @brief _̒lǂԂ܂
#define MIX_FLOAT_EQUAL( a, b ) ( ( ( ( a ) - MIX_FLOAT_EPSILON ) <= ( b ) ) && ( ( ( a ) + MIX_FLOAT_EPSILON ) >= ( b ) ) )
//! @def MIX_FLOAT_RECIPROCAL
//! @brief a ̋t߂܂
#define MIX_FLOAT_RECIPROCAL( a ) ( ( MIX_FLOAT_IS_ZERO( a ) == False )? ( 1.0f / ( a ) ) : 0.0f )
//! @def MIX_FLOAT_DIV
//! @brief a  b ŏZ܂
#define MIX_FLOAT_DIV( a, b ) ( ( MIX_FLOAT_IS_ZERO( b ) == False )? ( ( a ) / ( b ) ) : 0.0f )
//! @def MIX_FLOAT_SATURATE
//! @brief a  0.0f`1.0f ɖOa܂
#define MIX_FLOAT_SATURATE( a ) ( ( ( a ) < MIX_FLOAT_EPSILON )? 0.0f : ( ( a ) > 1.0f )? 1.0f : ( a ) )
//! @def MIX_CLAMP
//! @brief b <= a >= c ɂȂ悤 a Oa܂
#define MIX_CLAMP( a, b, c ) ( ( ( b ) > ( a ) )? ( b ) : ( ( c ) < ( a ) )? ( c ) : ( a ) )
