#pragma once

//! @file Mix/ScopedLock.h
//! @brief XR[vbNNXCN[ht@C

#include "Mix/Noncopyable.h"
#include "Mix/CriticalSection.h"

namespace Mix{

	//! @class ScopedLock
	//! @brief XR[vNX
	//! @note XR[v̓ƂۂɎgp邱Ƃł܂
	//! <pre>
	//! 
	//! Mix::CriticalSection m_Sync;
	//! void Test( void )
	//! {
	//!    Mix::ScopedLock lock( m_Sync );
	//!    ƂR[h
	//! }
	//! </pre>
	class _MIX_DLL_API ScopedLock : public Noncopyable
	{
	private:
		const Mix::CriticalSection& m_Sync;	//!< NeBJZNV

	public:
		//! @brief RXgN^
		//! @param[in] cs NeBJZNV
		ScopedLock( const Mix::CriticalSection& cs );
		//! @brief fXgN^
		~ScopedLock( void );
	};

}
